'Nastavenie pre prekladac BASCOM-AVR
$regfile = "attiny25.dat"
$crystal = 8000000
$hwstack = 16
$swstack = 16
$framesize = 16

'NASTAVENIE CASOVACOV PRE PWM
'BLIZSIE INFORMACIE V DATOVOM LISTE ATTINY25
'config timer0
Tccr0a = &B10100001                                         'fast pwm, active OC0A aj OC0B
Tccr0b = &B00000000                                         'stop

'config timer1
Tccr1 = &B00000000                                          'stoped
Gtccr = &B01100000
Ocr1c = 255                                                 'top value
Pllcsr = 0                                                  'all PLL functions disabled

'NASTAVEIE I/O PORTOV
'config portb
Config Portb = &B00010011
Portb = &B00101100                                          'pull-up enabled

'NASTAVENIE PRERUSENI
Config Int0 = Low Level
On Int0 _reset Nosave
Disable Int0

'DEFINOVANIE REGISTROV PRE PWM
Pwm_g Alias Ocr0b
Prm_r Alias Ocr0a
Pwm_b Alias Ocr1b

Rem PREMENNE
Dim Red As Byte , Green As Byte
Dim Blue As Byte
Dim Eram_red As Eram Byte , Eram_green As Eram Byte
Dim Eram_blue As Eram Byte
Dim In_byte As Byte
Dim Prog_no As Byte
Dim Eram_prog As Eram Byte
Dim Off_flag As Bit , Sel_flag As Bit

'******************************************************
Rem START
'******************************************************
'INICIALIZACIA PWM
Tcnt0 = 0 : Ocr0a = 0 : Ocr0b = 0
Tccr0b = &B00000011                                         'start
Tcnt1 = 0 : Ocr1b = 0
Tccr1 = &B00000111                                          'start
Prog_no = Eram_prog

'NACITANIE PROGRAMU Z EEPROM
If Prog_no = 255 Then Prog_no = 0
Gosub Prog_sel
Pwm_g = Green
Prm_r = Red
Pwm_b = Blue
Bitwait Pinb.2 , Set
Waitms 500

'******************************************************
'HLAVNA SLUCKA
Do
'NULOVANIE PRIZNAKOVYCH BITOV
Off_flag = 0 : Sel_flag = 0
In_byte = 0

'NACITANIE TLACIDIEL
In_byte.2 = Not Pinb.5 : In_byte.1 = Not Pinb.3 : In_byte.0 = Not Pinb.2

'VOLBA FUNKCIE TLACIDLA
Select Case In_byte
   Case 1 : Incr Blue
   Case 2 : Incr Green
   Case 5 : Eram_red = Red                                  'save
             Eram_green = Green
             Eram_blue = Blue
             Pwm_g = 0
             Prm_r = 0
             Pwm_b = 0
             Waitms 500
             Prog_no = 7
             Gosub Prog_sel
   Case 4 : Incr Red
   Case 3 : Eram_prog = Prog_no                             'on_off
             Red = 0
            Green = 0
            Blue = 0
            Off_flag = 1
   Case 6 : Incr Prog_no                                    'prog+
             If Prog_no = 8 Then Prog_no = 0
             Gosub Prog_sel
             Sel_flag = 1
End Select

'AKTUALIZACIA OCR REGISTROV PWM JEDNOTLIVYCH FARIEB
Pwm_g = Green
Prm_r = Red
Pwm_b = Blue

'SPRACOVANIE PRIZNAKOVYCH BITOV
If Sel_flag = 1 Then Waitms 500 Else Waitms 27
If Off_flag = 1 Then                                        'IDE DO POWER/DOWN MODU
                      Bitwait Pinb.2 , Set
                      Waitms 500
                      Enable Interrupts                     'POVOLI PRERUSENIE, ABY SA VEDEL Z POWER/DOWN ZOBUDIT
                      Enable Int0
                      Powerdown
                      'PRI ZOBUDENI POKRACUJE OD ZACIATKU PROGRAMU
End If
Loop                                                        'KONIEC HLAVNEJ SLUCKY
'******************************************************

'VOLBA FUNKCII PROGRAMOV
Prog_sel:
Select Case Prog_no
   Case 0 : Green = 255
            Red = 0
            Blue = 0
   Case 1 : Green = 0
            Red = 255
            Blue = 0
   Case 2 : Green = 0
            Red = 0
            Blue = 255
   Case 3 : Green = 255
            Red = 255
            Blue = 255
   Case 4 : Green = 255
            Red = 255
            Blue = 0
   Case 5 : Green = 255
            Red = 0
            Blue = 255
   Case 6 : Green = 0
            Red = 255
            Blue = 255
   Case 7 : Red = Eram_red
            Green = Eram_green
            Blue = Eram_blue
End Select
Return
