
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega162
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega162
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1279
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCSR=0x34
	.EQU MCUCR=0x35
	.EQU EMCUCR=0x36
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x04FF
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _s=R5
	.DEF _m=R4
	.DEF _n=R7
	.DEF _five=R6
	.DEF _mrhsetfive=R9
	.DEF _sm=R8
	.DEF _setup=R11
	.DEF _mrhset=R10
	.DEF _licensesel=R13
	.DEF _cllicset=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  _ext_int1_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_0x178:
	.DB  0x1,0x1
_0x0:
	.DB  0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30
	.DB  0x30,0x0,0x2D,0x6F,0x76,0x65,0x72,0x66
	.DB  0x6C,0x6F,0x77,0x2D,0x0,0x41,0x63,0x74
	.DB  0x69,0x76,0x61,0x74,0x65,0x20,0x66,0x69
	.DB  0x72,0x6D,0x77,0x61,0x72,0x65,0x21,0x0
	.DB  0x7C,0x0,0x44,0x69,0x67,0x69,0x74,0x61
	.DB  0x6C,0x20,0x64,0x6F,0x73,0x69,0x6D,0x65
	.DB  0x74,0x65,0x72,0x20,0x53,0x53,0x0,0x3E
	.DB  0x20,0x73,0x65,0x6C,0x65,0x63,0x74,0x20
	.DB  0x7C,0x20,0x23,0x20,0x65,0x6E,0x74,0x65
	.DB  0x72,0x0,0x41,0x63,0x74,0x69,0x76,0x61
	.DB  0x74,0x65,0x64,0x21,0x0,0x54,0x68,0x61
	.DB  0x6E,0x6B,0x73,0x20,0x79,0x6F,0x75,0x20
	.DB  0x66,0x6F,0x72,0x20,0x75,0x73,0x69,0x6E
	.DB  0x67,0x0,0x74,0x68,0x69,0x73,0x20,0x70
	.DB  0x72,0x6F,0x64,0x75,0x63,0x74,0x20,0x21
	.DB  0x0,0x53,0x69,0x6C,0x69,0x63,0x6F,0x6E
	.DB  0x2D,0x53,0x6F,0x75,0x72,0x63,0x65,0x20
	.DB  0x48,0x57,0x26,0x53,0x57,0x0,0x44,0x69
	.DB  0x67,0x69,0x74,0x61,0x6C,0x20,0x64,0x6F
	.DB  0x73,0x69,0x6D,0x65,0x74,0x65,0x72,0x20
	.DB  0x76,0x32,0x0,0x4C,0x6F,0x61,0x64,0x69
	.DB  0x6E,0x67,0x2C,0x20,0x70,0x6C,0x65,0x61
	.DB  0x73,0x65,0x20,0x77,0x61,0x69,0x74,0x0
	.DB  0x28,0x63,0x29,0x20,0x4A,0x69,0x72,0x69
	.DB  0x20,0x43,0x65,0x63,0x68,0x20,0x38,0x2F
	.DB  0x32,0x30,0x31,0x33,0x0,0x63,0x70,0x6D
	.DB  0x0,0x55,0x50,0x44,0x41,0x54,0x45,0x3A
	.DB  0x0,0x73,0x0,0x63,0x70,0x68,0x0,0x63
	.DB  0x74,0x74,0x0,0x2D,0x2D,0x2D,0x2D,0x2D
	.DB  0x0,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D,0x2D
	.DB  0x2D,0x2D,0x2D,0x0,0x75,0x52,0x2F,0x68
	.DB  0x0,0x6D,0x52,0x2F,0x68,0x0,0x2D,0x6F
	.DB  0x76,0x65,0x72,0x2D,0x0,0x4E,0x4F,0x52
	.DB  0x4D,0x2E,0x0,0x47,0x4F,0x4F,0x44,0x20
	.DB  0x0,0x78,0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  _0x5
	.DW  _0x0*2

	.DW  0x09
	.DW  _0x5+10
	.DW  _0x0*2+1

	.DW  0x08
	.DW  _0x5+19
	.DW  _0x0*2+2

	.DW  0x07
	.DW  _0x5+27
	.DW  _0x0*2+3

	.DW  0x06
	.DW  _0x5+34
	.DW  _0x0*2+4

	.DW  0x05
	.DW  _0x5+40
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x5+45
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x5+49
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x5+52
	.DW  _0x0*2+8

	.DW  0x0B
	.DW  _0x5+54
	.DW  _0x0*2+10

	.DW  0x13
	.DW  _0x26
	.DW  _0x0*2+21

	.DW  0x02
	.DW  _0x26+19
	.DW  _0x0*2+40

	.DW  0x02
	.DW  _0x26+21
	.DW  _0x0*2+40

	.DW  0x02
	.DW  _0x26+23
	.DW  _0x0*2+40

	.DW  0x15
	.DW  _0x26+25
	.DW  _0x0*2+42

	.DW  0x13
	.DW  _0x26+46
	.DW  _0x0*2+63

	.DW  0x0B
	.DW  _0x26+65
	.DW  _0x0*2+82

	.DW  0x15
	.DW  _0x26+76
	.DW  _0x0*2+93

	.DW  0x0F
	.DW  _0x26+97
	.DW  _0x0*2+114

	.DW  0x15
	.DW  _0x26+112
	.DW  _0x0*2+129

	.DW  0x15
	.DW  _0x26+133
	.DW  _0x0*2+150

	.DW  0x15
	.DW  _0x26+154
	.DW  _0x0*2+171

	.DW  0x15
	.DW  _0x26+175
	.DW  _0x0*2+192

	.DW  0x02
	.DW  _0x26+196
	.DW  _0x0*2+40

	.DW  0x04
	.DW  _0x26+198
	.DW  _0x0*2+213

	.DW  0x08
	.DW  _0x26+202
	.DW  _0x0*2+217

	.DW  0x02
	.DW  _0x26+210
	.DW  _0x0*2+225

	.DW  0x02
	.DW  _0x26+212
	.DW  _0x0*2+40

	.DW  0x04
	.DW  _0x26+214
	.DW  _0x0*2+227

	.DW  0x02
	.DW  _0x26+218
	.DW  _0x0*2+40

	.DW  0x02
	.DW  _0x26+220
	.DW  _0x0*2+40

	.DW  0x04
	.DW  _0x26+222
	.DW  _0x0*2+231

	.DW  0x06
	.DW  _0x26+226
	.DW  _0x0*2+235

	.DW  0x06
	.DW  _0x26+232
	.DW  _0x0*2+235

	.DW  0x05
	.DW  _0x26+238
	.DW  _0x0*2+236

	.DW  0x06
	.DW  _0x26+243
	.DW  _0x0*2+235

	.DW  0x06
	.DW  _0x26+249
	.DW  _0x0*2+235

	.DW  0x0B
	.DW  _0x26+255
	.DW  _0x0*2+241

	.DW  0x05
	.DW  _0x26+266
	.DW  _0x0*2+252

	.DW  0x05
	.DW  _0x26+271
	.DW  _0x0*2+257

	.DW  0x05
	.DW  _0x26+276
	.DW  _0x0*2+252

	.DW  0x05
	.DW  _0x26+281
	.DW  _0x0*2+257

	.DW  0x05
	.DW  _0x26+286
	.DW  _0x0*2+252

	.DW  0x05
	.DW  _0x26+291
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+296
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+300
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+303
	.DW  _0x0*2+8

	.DW  0x05
	.DW  _0x26+305
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+310
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+314
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+317
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x26+319
	.DW  _0x0*2+262

	.DW  0x06
	.DW  _0x26+326
	.DW  _0x0*2+269

	.DW  0x06
	.DW  _0x26+332
	.DW  _0x0*2+275

	.DW  0x02
	.DW  _0x26+338
	.DW  _0x0*2+8

	.DW  0x03
	.DW  _0x26+340
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+343
	.DW  _0x0*2+281

	.DW  0x02
	.DW  _0x26+345
	.DW  _0x0*2+8

	.DW  0x05
	.DW  _0x26+347
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+352
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+356
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+359
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x26+361
	.DW  _0x0*2+262

	.DW  0x05
	.DW  _0x26+368
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+373
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+377
	.DW  _0x0*2+7

	.DW  0x05
	.DW  _0x26+380
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+385
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+389
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+392
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x26+394
	.DW  _0x0*2+262

	.DW  0x05
	.DW  _0x26+401
	.DW  _0x0*2+5

	.DW  0x04
	.DW  _0x26+406
	.DW  _0x0*2+6

	.DW  0x03
	.DW  _0x26+410
	.DW  _0x0*2+7

	.DW  0x02
	.DW  _0x26+413
	.DW  _0x0*2+8

	.DW  0x07
	.DW  _0x26+415
	.DW  _0x0*2+262

	.DW  0x02
	.DW  0x0B
	.DW  _0x178*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30
	OUT  EMCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Digital dosimeter
;Version : v2
;Date    : 11.8.2013
;Author  : Ji ech
;Company : Silicon-Source HW&SW
;Comments: All rights reserved
;
;
;Chip type               : ATmega162
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega162.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.SET power_ctrl_reg=mcucr
	#endif
;
;
;
;// Alphanumeric LCD Module functions
;#include <delay.h>
;
;// Alphanumeric LCD Module functions
;#include <alcd.h>
;
;
;#include <stdlib.h>
;
;
;
;
;unsigned long  int cpm; //cycles per minute
;unsigned long int cph;  //cycles per hour
;char s;                 //second
;char m;                 //minute
;char n;                 //x norm overflow
;eeprom unsigned long int ctt; // total pulses
;unsigned long int urh; //uR/h sampling every minute
;unsigned long int mrh; //mR/h used only, when "urh" is too large
;
;unsigned long int urhfive;// uR/h sampling every 5 seconds
;unsigned char five;       // counter 5 seconds
;unsigned long int cpfive; // cycles per 5 seconds
;unsigned char mrhsetfive;  // switching between uR/h and mR/h per 5 seconds
;unsigned long int mrhfive; //mR/h used only, when "urh" is too large per 5 seconds
;
;char sm;                  // countdown timer for time notification
;
;unsigned char setup=1;     // if 1, start loading (Voltage stabilisation) if 0, GMT works.
;                          // Dosimeter can switch it to 0 automatically.
;unsigned char mrhset;     // switching between uR/h and mR/h
;
;eeprom unsigned char license;    //license
;unsigned char licensesel;        //license
;unsigned char cllicset=1; //lcd_clear(); only once
;
;
;
;
;
;
;
;unsigned char ava=0;       //license
;unsigned char avb=0;       //license
;unsigned char avc=0;       //license
;unsigned char avd=0;       //license
;unsigned char ave=0;       //license
;unsigned char avf=0;       //license
;unsigned char avg=0;       //license
;unsigned char avh=0;       //license
;unsigned char avi=0;       //license
;unsigned char avj=0;       //license
;unsigned char avk=0;       //license
;unsigned char avl=0;       //license
;unsigned char avm=0;       //license
;unsigned char avn=0;       //license
;unsigned char avo=0;       //license
;unsigned char avp=0;       //license
;unsigned char avq=0;       //license
;
;unsigned char a;       //license
;unsigned char b;       //license
;unsigned char c;       //license
;unsigned char d;       //license
;unsigned char e;       //license
;unsigned char f;       //license
;unsigned char g;       //license
;unsigned char h;       //license
;unsigned char i;       //license
;unsigned char j;       //license
;unsigned char k;       //license
;unsigned char l;       //license
;unsigned char m;       //license
;unsigned char n;       //license
;unsigned char o;       //license
;unsigned char p;       //license
;unsigned char q;       //license
;
;unsigned char ac[3];       //license
;unsigned char bc[3];       //license
;unsigned char cc[3];       //license
;unsigned char dc[3];       //license
;unsigned char ec[3];       //license
;unsigned char fc[3];       //license
;unsigned char gc[3];       //license
;unsigned char hc[3];       //license
;unsigned char ic[3];       //license
;unsigned char jc[3];       //license
;unsigned char kc[3];       //license
;unsigned char lc[3];       //license
;unsigned char mc[3];       //license
;unsigned char ncc[3];       //license
;unsigned char oc[3];       //license
;unsigned char pc[3];       //license
;unsigned char qc[3];       //license
;
;
;//variables converted to ASCII. Name was created, like name of variable and added was suffix "c"
;unsigned char urhfivec[15];
;unsigned char mrhfivec[15];
;unsigned char cpmc[15];
;unsigned char cphc[15];
;unsigned char cttc[27];
;unsigned char sc[6];
;unsigned char urhc[15];
;unsigned char nc[9];
;unsigned char mrhc[15];
;
;
;
;
;// External Interrupt 1 service routine
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 008E  {

	.CSEG
_ext_int1_isr:
	CALL SUBOPT_0x0
; 0000 008F 
; 0000 0090 
; 0000 0091 
; 0000 0092 
; 0000 0093 
; 0000 0094 if(setup!=1){
	LDI  R30,LOW(1)
	CP   R30,R11
	BRNE PC+3
	JMP _0x3
; 0000 0095 
; 0000 0096 cpfive++;
	LDI  R26,LOW(_cpfive)
	LDI  R27,HIGH(_cpfive)
	CALL SUBOPT_0x1
; 0000 0097 cpm++;
	LDI  R26,LOW(_cpm)
	LDI  R27,HIGH(_cpm)
	CALL SUBOPT_0x1
; 0000 0098 cph++;
	LDI  R26,LOW(_cph)
	LDI  R27,HIGH(_cph)
	CALL SUBOPT_0x1
; 0000 0099 ctt++;
	CALL SUBOPT_0x2
	__SUBD1N -1
	CALL __EEPROMWRD
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
; 0000 009A 
; 0000 009B 
; 0000 009C 
; 0000 009D 
; 0000 009E 
; 0000 009F 
; 0000 00A0 ltoa(ctt,cttc);
	CALL SUBOPT_0x2
	CALL __PUTPARD1
	CALL SUBOPT_0x3
	CALL _ltoa
; 0000 00A1 
; 0000 00A2 
; 0000 00A3 if(ctt<10){
	CALL SUBOPT_0x2
	CALL SUBOPT_0x4
	BRSH _0x4
; 0000 00A4 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00A5 lcd_puts("000000000");
	__POINTW1MN _0x5,0
	CALL SUBOPT_0x6
; 0000 00A6 lcd_gotoxy(15,3);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x7
; 0000 00A7 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00A8 }
; 0000 00A9 
; 0000 00AA if(ctt>9 && ctt<100){
_0x4:
	CALL SUBOPT_0x2
	CALL SUBOPT_0x4
	BRLO _0x7
	CALL SUBOPT_0x8
	BRLO _0x8
_0x7:
	RJMP _0x6
_0x8:
; 0000 00AB lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00AC lcd_puts("00000000");
	__POINTW1MN _0x5,10
	CALL SUBOPT_0x6
; 0000 00AD lcd_gotoxy(14,3);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x7
; 0000 00AE lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00AF }
; 0000 00B0 
; 0000 00B1 if(ctt>99 && ctt<1000){
_0x6:
	CALL SUBOPT_0x2
	CALL SUBOPT_0x8
	BRLO _0xA
	CALL SUBOPT_0x9
	BRLO _0xB
_0xA:
	RJMP _0x9
_0xB:
; 0000 00B2 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00B3 lcd_puts("0000000");
	__POINTW1MN _0x5,19
	CALL SUBOPT_0x6
; 0000 00B4 lcd_gotoxy(13,3);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x7
; 0000 00B5 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00B6 }
; 0000 00B7 
; 0000 00B8 if(ctt>999 && ctt<10000){
_0x9:
	CALL SUBOPT_0x2
	CALL SUBOPT_0x9
	BRLO _0xD
	CALL SUBOPT_0xA
	BRLO _0xE
_0xD:
	RJMP _0xC
_0xE:
; 0000 00B9 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00BA lcd_puts("000000");
	__POINTW1MN _0x5,27
	CALL SUBOPT_0x6
; 0000 00BB lcd_gotoxy(12,3);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x7
; 0000 00BC lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00BD }
; 0000 00BE 
; 0000 00BF if(ctt>9999 && ctt<100000 ){
_0xC:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xA
	BRLO _0x10
	CALL SUBOPT_0xB
	BRLO _0x11
_0x10:
	RJMP _0xF
_0x11:
; 0000 00C0 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00C1 lcd_puts("00000");
	__POINTW1MN _0x5,34
	CALL SUBOPT_0x6
; 0000 00C2 lcd_gotoxy(11,3);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x7
; 0000 00C3 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00C4 }
; 0000 00C5 if(ctt>99999 && ctt<100000){
_0xF:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xB
	BRLO _0x13
	CALL SUBOPT_0xB
	BRLO _0x14
_0x13:
	RJMP _0x12
_0x14:
; 0000 00C6 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00C7 lcd_puts("0000");
	__POINTW1MN _0x5,40
	CALL SUBOPT_0x6
; 0000 00C8 lcd_gotoxy(10,3);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x7
; 0000 00C9 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00CA }
; 0000 00CB if(ctt>999999 && ctt<1000000){
_0x12:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xC
	BRLO _0x16
	CALL SUBOPT_0xC
	BRLO _0x17
_0x16:
	RJMP _0x15
_0x17:
; 0000 00CC lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00CD lcd_puts("000");
	__POINTW1MN _0x5,45
	CALL SUBOPT_0x6
; 0000 00CE lcd_gotoxy(9,3);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x7
; 0000 00CF lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00D0 
; 0000 00D1 }
; 0000 00D2 
; 0000 00D3 if(ctt>999999 && ctt<1000000){
_0x15:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xC
	BRLO _0x19
	CALL SUBOPT_0xC
	BRLO _0x1A
_0x19:
	RJMP _0x18
_0x1A:
; 0000 00D4 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00D5 lcd_puts("00");
	__POINTW1MN _0x5,49
	CALL SUBOPT_0x6
; 0000 00D6 lcd_gotoxy(8,3);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x7
; 0000 00D7 lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00D8 }
; 0000 00D9 
; 0000 00DA if(ctt>9999999 && ctt<10000000){
_0x18:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xD
	BRLO _0x1C
	CALL SUBOPT_0xD
	BRLO _0x1D
_0x1C:
	RJMP _0x1B
_0x1D:
; 0000 00DB lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00DC lcd_puts("0");
	__POINTW1MN _0x5,52
	CALL SUBOPT_0x6
; 0000 00DD lcd_gotoxy(7,3);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x7
; 0000 00DE lcd_puts(cttc);
	CALL _lcd_puts
; 0000 00DF }
; 0000 00E0 
; 0000 00E1 if(ctt>99999999 && ctt<100000000){
_0x1B:
	CALL SUBOPT_0x2
	CALL SUBOPT_0xE
	BRLO _0x1F
	CALL SUBOPT_0xE
	BRLO _0x20
_0x1F:
	RJMP _0x1E
_0x20:
; 0000 00E2 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00E3 lcd_puts(cttc);
	CALL SUBOPT_0x3
	CALL _lcd_puts
; 0000 00E4 }
; 0000 00E5 
; 0000 00E6 if(ctt>9999999999){
_0x1E:
	CALL SUBOPT_0x2
	CALL __CDF1U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x501502F9
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x21
; 0000 00E7 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 00E8 lcd_puts("-overflow-");
	__POINTW1MN _0x5,54
	CALL SUBOPT_0x6
; 0000 00E9 }
; 0000 00EA 
; 0000 00EB }
_0x21:
; 0000 00EC }
_0x3:
	CALL SUBOPT_0xF
	RETI

	.DSEG
_0x5:
	.BYTE 0x41
;
;
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00F2 {

	.CSEG
_timer2_ovf_isr:
	CALL SUBOPT_0x0
; 0000 00F3 // Place your code here
; 0000 00F4 five++;
	INC  R6
; 0000 00F5 
; 0000 00F6 
; 0000 00F7  while(license!=1){
_0x22:
	LDI  R26,LOW(_license)
	LDI  R27,HIGH(_license)
	CALL __EEPROMRDB
	CPI  R30,LOW(0x1)
	BRNE PC+3
	JMP _0x24
; 0000 00F8     if(cllicset==1){
	LDI  R30,LOW(1)
	CP   R30,R12
	BRNE _0x25
; 0000 00F9     lcd_clear();
	CALL _lcd_clear
; 0000 00FA     cllicset=0;
	CLR  R12
; 0000 00FB     }
; 0000 00FC     lcd_gotoxy(0,0);
_0x25:
	CALL SUBOPT_0x10
; 0000 00FD     lcd_puts("Activate firmware!");
	__POINTW1MN _0x26,0
	CALL SUBOPT_0x6
; 0000 00FE     lcd_gotoxy(4,1);
	CALL SUBOPT_0x11
; 0000 00FF     lcd_puts("|");
	__POINTW1MN _0x26,19
	CALL SUBOPT_0x6
; 0000 0100     lcd_gotoxy(9,1);
	CALL SUBOPT_0x12
; 0000 0101     lcd_puts("|");
	__POINTW1MN _0x26,21
	CALL SUBOPT_0x6
; 0000 0102     lcd_gotoxy(14,1);
	CALL SUBOPT_0x13
; 0000 0103     lcd_puts("|");
	__POINTW1MN _0x26,23
	CALL SUBOPT_0x6
; 0000 0104     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 0105     lcd_puts("Digital dosimeter SS");
	__POINTW1MN _0x26,25
	CALL SUBOPT_0x6
; 0000 0106     lcd_gotoxy(2,3);
	CALL SUBOPT_0x15
; 0000 0107     lcd_puts("> select | # enter");
	__POINTW1MN _0x26,46
	CALL SUBOPT_0x6
; 0000 0108 
; 0000 0109 
; 0000 010A 
; 0000 010B         if(PINC.1==1){
	SBIS 0x13,1
	RJMP _0x27
; 0000 010C         delay_ms(80);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	CALL SUBOPT_0x16
; 0000 010D         if(PINC.1==1){
	SBIS 0x13,1
	RJMP _0x28
; 0000 010E         while(PINC.1==1){}
_0x29:
	SBIC 0x13,1
	RJMP _0x29
; 0000 010F         if(licensesel<18){
	LDI  R30,LOW(18)
	CP   R13,R30
	BRSH _0x2C
; 0000 0110         licensesel++;
	INC  R13
; 0000 0111         }
; 0000 0112         if(licensesel>17){
_0x2C:
	LDI  R30,LOW(17)
	CP   R30,R13
	BRSH _0x2D
; 0000 0113         licensesel=0;
	CLR  R13
; 0000 0114         }
; 0000 0115         }
_0x2D:
; 0000 0116         }
_0x28:
; 0000 0117 
; 0000 0118 
; 0000 0119 
; 0000 011A         if(licensesel==0 && PINC.0==1)
_0x27:
	LDI  R30,LOW(0)
	CP   R30,R13
	BRNE _0x2F
	SBIC 0x13,0
	RJMP _0x30
_0x2F:
	RJMP _0x2E
_0x30:
; 0000 011B         {
; 0000 011C         while(PINC.0==1){}
_0x31:
	SBIC 0x13,0
	RJMP _0x31
; 0000 011D         if(a!=10){
	LDS  R26,_a
	CPI  R26,LOW(0xA)
	BREQ _0x34
; 0000 011E         a++;
	LDS  R30,_a
	SUBI R30,-LOW(1)
	STS  _a,R30
; 0000 011F         }
; 0000 0120         if(a==10){
_0x34:
	LDS  R26,_a
	CPI  R26,LOW(0xA)
	BRNE _0x35
; 0000 0121         a=0;
	LDI  R30,LOW(0)
	STS  _a,R30
; 0000 0122         }
; 0000 0123         }
_0x35:
; 0000 0124 
; 0000 0125         if(licensesel==1 && PINC.0==1)
_0x2E:
	LDI  R30,LOW(1)
	CP   R30,R13
	BRNE _0x37
	SBIC 0x13,0
	RJMP _0x38
_0x37:
	RJMP _0x36
_0x38:
; 0000 0126         {
; 0000 0127         while(PINC.0==1){}
_0x39:
	SBIC 0x13,0
	RJMP _0x39
; 0000 0128         if(b!=10){
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BREQ _0x3C
; 0000 0129         b++;
	LDS  R30,_b
	SUBI R30,-LOW(1)
	STS  _b,R30
; 0000 012A         }
; 0000 012B         if(b==10){
_0x3C:
	LDS  R26,_b
	CPI  R26,LOW(0xA)
	BRNE _0x3D
; 0000 012C         b=0;
	LDI  R30,LOW(0)
	STS  _b,R30
; 0000 012D         }
; 0000 012E         }
_0x3D:
; 0000 012F 
; 0000 0130         if(licensesel==2 && PINC.0==1)
_0x36:
	LDI  R30,LOW(2)
	CP   R30,R13
	BRNE _0x3F
	SBIC 0x13,0
	RJMP _0x40
_0x3F:
	RJMP _0x3E
_0x40:
; 0000 0131         {
; 0000 0132         while(PINC.0==1){}
_0x41:
	SBIC 0x13,0
	RJMP _0x41
; 0000 0133         if(c!=10){
	LDS  R26,_c
	CPI  R26,LOW(0xA)
	BREQ _0x44
; 0000 0134         c++;
	LDS  R30,_c
	SUBI R30,-LOW(1)
	STS  _c,R30
; 0000 0135         }
; 0000 0136         if(c==10){
_0x44:
	LDS  R26,_c
	CPI  R26,LOW(0xA)
	BRNE _0x45
; 0000 0137         c=0;
	LDI  R30,LOW(0)
	STS  _c,R30
; 0000 0138         }
; 0000 0139 
; 0000 013A 
; 0000 013B         }
_0x45:
; 0000 013C 
; 0000 013D         if(licensesel==3 && PINC.0==1)
_0x3E:
	LDI  R30,LOW(3)
	CP   R30,R13
	BRNE _0x47
	SBIC 0x13,0
	RJMP _0x48
_0x47:
	RJMP _0x46
_0x48:
; 0000 013E         {
; 0000 013F         while(PINC.0==1){}
_0x49:
	SBIC 0x13,0
	RJMP _0x49
; 0000 0140         if(d!=10){
	LDS  R26,_d
	CPI  R26,LOW(0xA)
	BREQ _0x4C
; 0000 0141         d++;
	LDS  R30,_d
	SUBI R30,-LOW(1)
	STS  _d,R30
; 0000 0142         }
; 0000 0143         if(d==10){
_0x4C:
	LDS  R26,_d
	CPI  R26,LOW(0xA)
	BRNE _0x4D
; 0000 0144         d=0;
	LDI  R30,LOW(0)
	STS  _d,R30
; 0000 0145         }
; 0000 0146 
; 0000 0147 
; 0000 0148         }
_0x4D:
; 0000 0149 
; 0000 014A         if(licensesel==4 && PINC.0==1)
_0x46:
	LDI  R30,LOW(4)
	CP   R30,R13
	BRNE _0x4F
	SBIC 0x13,0
	RJMP _0x50
_0x4F:
	RJMP _0x4E
_0x50:
; 0000 014B         {
; 0000 014C         while(PINC.0==1){}
_0x51:
	SBIC 0x13,0
	RJMP _0x51
; 0000 014D         if(e!=10){
	LDS  R26,_e
	CPI  R26,LOW(0xA)
	BREQ _0x54
; 0000 014E         e++;
	LDS  R30,_e
	SUBI R30,-LOW(1)
	STS  _e,R30
; 0000 014F         }
; 0000 0150         if(e==10){
_0x54:
	LDS  R26,_e
	CPI  R26,LOW(0xA)
	BRNE _0x55
; 0000 0151         e=0;
	LDI  R30,LOW(0)
	STS  _e,R30
; 0000 0152         }
; 0000 0153 
; 0000 0154 
; 0000 0155         }
_0x55:
; 0000 0156 
; 0000 0157         if(licensesel==5 && PINC.0==1)
_0x4E:
	LDI  R30,LOW(5)
	CP   R30,R13
	BRNE _0x57
	SBIC 0x13,0
	RJMP _0x58
_0x57:
	RJMP _0x56
_0x58:
; 0000 0158         {
; 0000 0159         while(PINC.0==1){}
_0x59:
	SBIC 0x13,0
	RJMP _0x59
; 0000 015A         if(f!=10){
	LDS  R26,_f
	CPI  R26,LOW(0xA)
	BREQ _0x5C
; 0000 015B         f++;
	LDS  R30,_f
	SUBI R30,-LOW(1)
	STS  _f,R30
; 0000 015C         }
; 0000 015D         if(f==10){
_0x5C:
	LDS  R26,_f
	CPI  R26,LOW(0xA)
	BRNE _0x5D
; 0000 015E         f=0;
	LDI  R30,LOW(0)
	STS  _f,R30
; 0000 015F         }
; 0000 0160 
; 0000 0161 
; 0000 0162         }
_0x5D:
; 0000 0163 
; 0000 0164         if(licensesel==6 && PINC.0==1)
_0x56:
	LDI  R30,LOW(6)
	CP   R30,R13
	BRNE _0x5F
	SBIC 0x13,0
	RJMP _0x60
_0x5F:
	RJMP _0x5E
_0x60:
; 0000 0165         {
; 0000 0166         while(PINC.0==1){}
_0x61:
	SBIC 0x13,0
	RJMP _0x61
; 0000 0167         if(g!=10){
	LDS  R26,_g
	CPI  R26,LOW(0xA)
	BREQ _0x64
; 0000 0168         g++;
	LDS  R30,_g
	SUBI R30,-LOW(1)
	STS  _g,R30
; 0000 0169         }
; 0000 016A         if(g==10){
_0x64:
	LDS  R26,_g
	CPI  R26,LOW(0xA)
	BRNE _0x65
; 0000 016B         g=0;
	LDI  R30,LOW(0)
	STS  _g,R30
; 0000 016C         }
; 0000 016D 
; 0000 016E 
; 0000 016F         }
_0x65:
; 0000 0170 
; 0000 0171         if(licensesel==7 && PINC.0==1)
_0x5E:
	LDI  R30,LOW(7)
	CP   R30,R13
	BRNE _0x67
	SBIC 0x13,0
	RJMP _0x68
_0x67:
	RJMP _0x66
_0x68:
; 0000 0172         {
; 0000 0173         while(PINC.0==1){}
_0x69:
	SBIC 0x13,0
	RJMP _0x69
; 0000 0174         if(h!=10){
	LDS  R26,_h
	CPI  R26,LOW(0xA)
	BREQ _0x6C
; 0000 0175         h++;
	LDS  R30,_h
	SUBI R30,-LOW(1)
	STS  _h,R30
; 0000 0176         }
; 0000 0177         if(h==10){
_0x6C:
	LDS  R26,_h
	CPI  R26,LOW(0xA)
	BRNE _0x6D
; 0000 0178         h=0;
	LDI  R30,LOW(0)
	STS  _h,R30
; 0000 0179         }
; 0000 017A 
; 0000 017B 
; 0000 017C         }
_0x6D:
; 0000 017D 
; 0000 017E         if(licensesel==8 && PINC.0==1)
_0x66:
	LDI  R30,LOW(8)
	CP   R30,R13
	BRNE _0x6F
	SBIC 0x13,0
	RJMP _0x70
_0x6F:
	RJMP _0x6E
_0x70:
; 0000 017F         {
; 0000 0180         while(PINC.0==1){}
_0x71:
	SBIC 0x13,0
	RJMP _0x71
; 0000 0181         if(i!=10){
	LDS  R26,_i
	CPI  R26,LOW(0xA)
	BREQ _0x74
; 0000 0182         i++;
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
; 0000 0183         }
; 0000 0184         if(i==10){
_0x74:
	LDS  R26,_i
	CPI  R26,LOW(0xA)
	BRNE _0x75
; 0000 0185         i=0;
	LDI  R30,LOW(0)
	STS  _i,R30
; 0000 0186         }
; 0000 0187 
; 0000 0188 
; 0000 0189         }
_0x75:
; 0000 018A 
; 0000 018B         if(licensesel==9 && PINC.0==1)
_0x6E:
	LDI  R30,LOW(9)
	CP   R30,R13
	BRNE _0x77
	SBIC 0x13,0
	RJMP _0x78
_0x77:
	RJMP _0x76
_0x78:
; 0000 018C         {
; 0000 018D         while(PINC.0==1){}
_0x79:
	SBIC 0x13,0
	RJMP _0x79
; 0000 018E         if(j!=10){
	LDS  R26,_j
	CPI  R26,LOW(0xA)
	BREQ _0x7C
; 0000 018F         j++;
	LDS  R30,_j
	SUBI R30,-LOW(1)
	STS  _j,R30
; 0000 0190         }
; 0000 0191         if(j==10){
_0x7C:
	LDS  R26,_j
	CPI  R26,LOW(0xA)
	BRNE _0x7D
; 0000 0192         j=0;
	LDI  R30,LOW(0)
	STS  _j,R30
; 0000 0193         }
; 0000 0194 
; 0000 0195 
; 0000 0196         }
_0x7D:
; 0000 0197 
; 0000 0198         if(licensesel==10 && PINC.0==1)
_0x76:
	LDI  R30,LOW(10)
	CP   R30,R13
	BRNE _0x7F
	SBIC 0x13,0
	RJMP _0x80
_0x7F:
	RJMP _0x7E
_0x80:
; 0000 0199         {
; 0000 019A         while(PINC.0==1){}
_0x81:
	SBIC 0x13,0
	RJMP _0x81
; 0000 019B         if(k!=10){
	LDS  R26,_k
	CPI  R26,LOW(0xA)
	BREQ _0x84
; 0000 019C         k++;
	LDS  R30,_k
	SUBI R30,-LOW(1)
	STS  _k,R30
; 0000 019D         }
; 0000 019E         if(k==10){
_0x84:
	LDS  R26,_k
	CPI  R26,LOW(0xA)
	BRNE _0x85
; 0000 019F         k=0;
	LDI  R30,LOW(0)
	STS  _k,R30
; 0000 01A0         }
; 0000 01A1 
; 0000 01A2 
; 0000 01A3         }
_0x85:
; 0000 01A4 
; 0000 01A5         if(licensesel==11 && PINC.0==1)
_0x7E:
	LDI  R30,LOW(11)
	CP   R30,R13
	BRNE _0x87
	SBIC 0x13,0
	RJMP _0x88
_0x87:
	RJMP _0x86
_0x88:
; 0000 01A6         {
; 0000 01A7         while(PINC.0==1){}
_0x89:
	SBIC 0x13,0
	RJMP _0x89
; 0000 01A8         if(l!=10){
	LDS  R26,_l
	CPI  R26,LOW(0xA)
	BREQ _0x8C
; 0000 01A9         l++;
	LDS  R30,_l
	SUBI R30,-LOW(1)
	STS  _l,R30
; 0000 01AA         }
; 0000 01AB         if(l==10){
_0x8C:
	LDS  R26,_l
	CPI  R26,LOW(0xA)
	BRNE _0x8D
; 0000 01AC         l=0;
	LDI  R30,LOW(0)
	STS  _l,R30
; 0000 01AD         }
; 0000 01AE 
; 0000 01AF 
; 0000 01B0         }
_0x8D:
; 0000 01B1 
; 0000 01B2         if(licensesel==12 && PINC.0==1)
_0x86:
	LDI  R30,LOW(12)
	CP   R30,R13
	BRNE _0x8F
	SBIC 0x13,0
	RJMP _0x90
_0x8F:
	RJMP _0x8E
_0x90:
; 0000 01B3         {
; 0000 01B4         while(PINC.0==1){}
_0x91:
	SBIC 0x13,0
	RJMP _0x91
; 0000 01B5         if(m!=10){
	LDI  R30,LOW(10)
	CP   R30,R4
	BREQ _0x94
; 0000 01B6         m++;
	INC  R4
; 0000 01B7         }
; 0000 01B8         if(m==10){
_0x94:
	LDI  R30,LOW(10)
	CP   R30,R4
	BRNE _0x95
; 0000 01B9         m=0;
	CLR  R4
; 0000 01BA         }
; 0000 01BB 
; 0000 01BC 
; 0000 01BD         }
_0x95:
; 0000 01BE 
; 0000 01BF         if(licensesel==13 && PINC.0==1)
_0x8E:
	LDI  R30,LOW(13)
	CP   R30,R13
	BRNE _0x97
	SBIC 0x13,0
	RJMP _0x98
_0x97:
	RJMP _0x96
_0x98:
; 0000 01C0         {
; 0000 01C1         while(PINC.0==1){}
_0x99:
	SBIC 0x13,0
	RJMP _0x99
; 0000 01C2         if(n!=10){
	LDI  R30,LOW(10)
	CP   R30,R7
	BREQ _0x9C
; 0000 01C3         n++;
	INC  R7
; 0000 01C4         }
; 0000 01C5         if(n==10){
_0x9C:
	LDI  R30,LOW(10)
	CP   R30,R7
	BRNE _0x9D
; 0000 01C6         n=0;
	CLR  R7
; 0000 01C7         }
; 0000 01C8 
; 0000 01C9 
; 0000 01CA         }
_0x9D:
; 0000 01CB 
; 0000 01CC         if(licensesel==14 && PINC.0==1)
_0x96:
	LDI  R30,LOW(14)
	CP   R30,R13
	BRNE _0x9F
	SBIC 0x13,0
	RJMP _0xA0
_0x9F:
	RJMP _0x9E
_0xA0:
; 0000 01CD         {
; 0000 01CE         while(PINC.0==1){}
_0xA1:
	SBIC 0x13,0
	RJMP _0xA1
; 0000 01CF         if(o!=10){
	LDS  R26,_o
	CPI  R26,LOW(0xA)
	BREQ _0xA4
; 0000 01D0         o++;
	LDS  R30,_o
	SUBI R30,-LOW(1)
	STS  _o,R30
; 0000 01D1         }
; 0000 01D2         if(o==10){
_0xA4:
	LDS  R26,_o
	CPI  R26,LOW(0xA)
	BRNE _0xA5
; 0000 01D3         o=0;
	LDI  R30,LOW(0)
	STS  _o,R30
; 0000 01D4         }
; 0000 01D5 
; 0000 01D6 
; 0000 01D7         }
_0xA5:
; 0000 01D8 
; 0000 01D9         if(licensesel==15 && PINC.0==1)
_0x9E:
	LDI  R30,LOW(15)
	CP   R30,R13
	BRNE _0xA7
	SBIC 0x13,0
	RJMP _0xA8
_0xA7:
	RJMP _0xA6
_0xA8:
; 0000 01DA         {
; 0000 01DB         while(PINC.0==1){}
_0xA9:
	SBIC 0x13,0
	RJMP _0xA9
; 0000 01DC         if(p!=10){
	LDS  R26,_p
	CPI  R26,LOW(0xA)
	BREQ _0xAC
; 0000 01DD         p++;
	LDS  R30,_p
	SUBI R30,-LOW(1)
	STS  _p,R30
; 0000 01DE         }
; 0000 01DF         if(p==10){
_0xAC:
	LDS  R26,_p
	CPI  R26,LOW(0xA)
	BRNE _0xAD
; 0000 01E0         p=0;
	LDI  R30,LOW(0)
	STS  _p,R30
; 0000 01E1         }
; 0000 01E2 
; 0000 01E3 
; 0000 01E4         }
_0xAD:
; 0000 01E5 
; 0000 01E6 
; 0000 01E7 
; 0000 01E8         if(licensesel==16 && PINC.0==1)
_0xA6:
	LDI  R30,LOW(16)
	CP   R30,R13
	BRNE _0xAF
	SBIC 0x13,0
	RJMP _0xB0
_0xAF:
	RJMP _0xAE
_0xB0:
; 0000 01E9         {
; 0000 01EA         while(PINC.0==1){}
_0xB1:
	SBIC 0x13,0
	RJMP _0xB1
; 0000 01EB         if(q!=10){
	LDS  R26,_q
	CPI  R26,LOW(0xA)
	BREQ _0xB4
; 0000 01EC         q++;
	LDS  R30,_q
	SUBI R30,-LOW(1)
	STS  _q,R30
; 0000 01ED         }
; 0000 01EE         if(q==10){
_0xB4:
	LDS  R26,_q
	CPI  R26,LOW(0xA)
	BRNE _0xB5
; 0000 01EF         q=0;
	LDI  R30,LOW(0)
	STS  _q,R30
; 0000 01F0         }
; 0000 01F1         }
_0xB5:
; 0000 01F2 
; 0000 01F3         itoa(a,ac);
_0xAE:
	LDS  R30,_a
	CALL SUBOPT_0x17
	LDI  R30,LOW(_ac)
	LDI  R31,HIGH(_ac)
	CALL SUBOPT_0x18
; 0000 01F4         itoa(b,bc);
	LDS  R30,_b
	CALL SUBOPT_0x17
	LDI  R30,LOW(_bc)
	LDI  R31,HIGH(_bc)
	CALL SUBOPT_0x18
; 0000 01F5         itoa(c,cc);
	LDS  R30,_c
	CALL SUBOPT_0x17
	LDI  R30,LOW(_cc)
	LDI  R31,HIGH(_cc)
	CALL SUBOPT_0x18
; 0000 01F6         itoa(d,dc);
	LDS  R30,_d
	CALL SUBOPT_0x17
	LDI  R30,LOW(_dc)
	LDI  R31,HIGH(_dc)
	CALL SUBOPT_0x18
; 0000 01F7         itoa(e,ec);
	LDS  R30,_e
	CALL SUBOPT_0x17
	LDI  R30,LOW(_ec)
	LDI  R31,HIGH(_ec)
	CALL SUBOPT_0x18
; 0000 01F8         itoa(f,fc);
	LDS  R30,_f
	CALL SUBOPT_0x17
	LDI  R30,LOW(_fc)
	LDI  R31,HIGH(_fc)
	CALL SUBOPT_0x18
; 0000 01F9         itoa(g,gc);
	LDS  R30,_g
	CALL SUBOPT_0x17
	LDI  R30,LOW(_gc)
	LDI  R31,HIGH(_gc)
	CALL SUBOPT_0x18
; 0000 01FA         itoa(h,hc);
	LDS  R30,_h
	CALL SUBOPT_0x17
	LDI  R30,LOW(_hc)
	LDI  R31,HIGH(_hc)
	CALL SUBOPT_0x18
; 0000 01FB         itoa(i,ic);
	LDS  R30,_i
	CALL SUBOPT_0x17
	LDI  R30,LOW(_ic)
	LDI  R31,HIGH(_ic)
	CALL SUBOPT_0x18
; 0000 01FC         itoa(j,jc);
	LDS  R30,_j
	CALL SUBOPT_0x17
	LDI  R30,LOW(_jc)
	LDI  R31,HIGH(_jc)
	CALL SUBOPT_0x18
; 0000 01FD         itoa(k,kc);
	LDS  R30,_k
	CALL SUBOPT_0x17
	LDI  R30,LOW(_kc)
	LDI  R31,HIGH(_kc)
	CALL SUBOPT_0x18
; 0000 01FE         itoa(l,lc);
	LDS  R30,_l
	CALL SUBOPT_0x17
	LDI  R30,LOW(_lc)
	LDI  R31,HIGH(_lc)
	CALL SUBOPT_0x18
; 0000 01FF         itoa(m,mc);
	MOV  R30,R4
	CALL SUBOPT_0x17
	LDI  R30,LOW(_mc)
	LDI  R31,HIGH(_mc)
	CALL SUBOPT_0x18
; 0000 0200         itoa(n,ncc);
	MOV  R30,R7
	CALL SUBOPT_0x17
	LDI  R30,LOW(_ncc)
	LDI  R31,HIGH(_ncc)
	CALL SUBOPT_0x18
; 0000 0201         itoa(o,oc);
	LDS  R30,_o
	CALL SUBOPT_0x17
	LDI  R30,LOW(_oc)
	LDI  R31,HIGH(_oc)
	CALL SUBOPT_0x18
; 0000 0202         itoa(p,pc);
	LDS  R30,_p
	CALL SUBOPT_0x17
	LDI  R30,LOW(_pc)
	LDI  R31,HIGH(_pc)
	CALL SUBOPT_0x18
; 0000 0203         itoa(q,qc);
	LDS  R30,_q
	CALL SUBOPT_0x17
	LDI  R30,LOW(_qc)
	LDI  R31,HIGH(_qc)
	CALL SUBOPT_0x18
; 0000 0204 
; 0000 0205         lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0206         lcd_puts(ac);
	LDI  R30,LOW(_ac)
	LDI  R31,HIGH(_ac)
	CALL SUBOPT_0x6
; 0000 0207 
; 0000 0208         lcd_gotoxy(1,1);
	CALL SUBOPT_0x1A
; 0000 0209         lcd_puts(bc);
	LDI  R30,LOW(_bc)
	LDI  R31,HIGH(_bc)
	CALL SUBOPT_0x6
; 0000 020A 
; 0000 020B         lcd_gotoxy(2,1);
	CALL SUBOPT_0x1B
; 0000 020C         lcd_puts(cc);
	LDI  R30,LOW(_cc)
	LDI  R31,HIGH(_cc)
	CALL SUBOPT_0x6
; 0000 020D 
; 0000 020E         lcd_gotoxy(3,1);
	CALL SUBOPT_0x1C
; 0000 020F         lcd_puts(dc);
	LDI  R30,LOW(_dc)
	LDI  R31,HIGH(_dc)
	CALL SUBOPT_0x6
; 0000 0210 
; 0000 0211         lcd_gotoxy(5,1);
	CALL SUBOPT_0x1D
; 0000 0212         lcd_puts(ec);
	LDI  R30,LOW(_ec)
	LDI  R31,HIGH(_ec)
	CALL SUBOPT_0x6
; 0000 0213 
; 0000 0214         lcd_gotoxy(6,1);
	CALL SUBOPT_0x1E
; 0000 0215         lcd_puts(fc);
	LDI  R30,LOW(_fc)
	LDI  R31,HIGH(_fc)
	CALL SUBOPT_0x6
; 0000 0216 
; 0000 0217         lcd_gotoxy(7,1);
	CALL SUBOPT_0x1F
; 0000 0218         lcd_puts(gc);
	LDI  R30,LOW(_gc)
	LDI  R31,HIGH(_gc)
	CALL SUBOPT_0x6
; 0000 0219 
; 0000 021A         lcd_gotoxy(8,1);
	CALL SUBOPT_0x20
; 0000 021B         lcd_puts(hc);
	LDI  R30,LOW(_hc)
	LDI  R31,HIGH(_hc)
	CALL SUBOPT_0x6
; 0000 021C 
; 0000 021D         lcd_gotoxy(10,1);
	CALL SUBOPT_0x21
; 0000 021E         lcd_puts(ic);
	LDI  R30,LOW(_ic)
	LDI  R31,HIGH(_ic)
	CALL SUBOPT_0x6
; 0000 021F 
; 0000 0220         lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0221         lcd_puts(jc);
	LDI  R30,LOW(_jc)
	LDI  R31,HIGH(_jc)
	CALL SUBOPT_0x6
; 0000 0222 
; 0000 0223         lcd_gotoxy(12,1);
	CALL SUBOPT_0x23
; 0000 0224         lcd_puts(kc);
	LDI  R30,LOW(_kc)
	LDI  R31,HIGH(_kc)
	CALL SUBOPT_0x6
; 0000 0225 
; 0000 0226         lcd_gotoxy(13,1);
	CALL SUBOPT_0x24
; 0000 0227         lcd_puts(lc);
	LDI  R30,LOW(_lc)
	LDI  R31,HIGH(_lc)
	CALL SUBOPT_0x6
; 0000 0228 
; 0000 0229         lcd_gotoxy(15,1);
	CALL SUBOPT_0x25
; 0000 022A         lcd_puts(mc);
	LDI  R30,LOW(_mc)
	LDI  R31,HIGH(_mc)
	CALL SUBOPT_0x6
; 0000 022B 
; 0000 022C         lcd_gotoxy(16,1);
	CALL SUBOPT_0x26
; 0000 022D         lcd_puts(ncc);
	LDI  R30,LOW(_ncc)
	LDI  R31,HIGH(_ncc)
	CALL SUBOPT_0x6
; 0000 022E 
; 0000 022F         lcd_gotoxy(17,1);
	CALL SUBOPT_0x27
; 0000 0230         lcd_puts(oc);
	LDI  R30,LOW(_oc)
	LDI  R31,HIGH(_oc)
	CALL SUBOPT_0x6
; 0000 0231 
; 0000 0232         lcd_gotoxy(18,1);
	CALL SUBOPT_0x28
; 0000 0233         lcd_puts(pc);
	LDI  R30,LOW(_pc)
	LDI  R31,HIGH(_pc)
	CALL SUBOPT_0x6
; 0000 0234 
; 0000 0235         lcd_gotoxy(19,1);
	CALL SUBOPT_0x29
; 0000 0236         lcd_puts(qc);
	LDI  R30,LOW(_qc)
	LDI  R31,HIGH(_qc)
	CALL SUBOPT_0x6
; 0000 0237 
; 0000 0238 
; 0000 0239 
; 0000 023A 
; 0000 023B 
; 0000 023C  if(licensesel==17){
	LDI  R30,LOW(17)
	CP   R30,R13
	BREQ PC+3
	JMP _0xB6
; 0000 023D          while(PINC.1==1){}
_0xB7:
	SBIC 0x13,1
	RJMP _0xB7
; 0000 023E 
; 0000 023F 
; 0000 0240        if(a==ava){
	LDS  R30,_ava
	LDS  R26,_a
	CP   R30,R26
	BREQ PC+3
	JMP _0xBA
; 0000 0241         if(b==avb){
	LDS  R30,_avb
	LDS  R26,_b
	CP   R30,R26
	BREQ PC+3
	JMP _0xBB
; 0000 0242          if(c==avc){
	LDS  R30,_avc
	LDS  R26,_c
	CP   R30,R26
	BREQ PC+3
	JMP _0xBC
; 0000 0243           if(d==avd){
	LDS  R30,_avd
	LDS  R26,_d
	CP   R30,R26
	BREQ PC+3
	JMP _0xBD
; 0000 0244            if(e==ave){
	LDS  R30,_ave
	LDS  R26,_e
	CP   R30,R26
	BREQ PC+3
	JMP _0xBE
; 0000 0245             if(f==avf){
	LDS  R30,_avf
	LDS  R26,_f
	CP   R30,R26
	BREQ PC+3
	JMP _0xBF
; 0000 0246              if(g==avg){
	LDS  R30,_avg
	LDS  R26,_g
	CP   R30,R26
	BREQ PC+3
	JMP _0xC0
; 0000 0247               if(h==avh){
	LDS  R30,_avh
	LDS  R26,_h
	CP   R30,R26
	BREQ PC+3
	JMP _0xC1
; 0000 0248                if(i==avi){
	LDS  R30,_avi
	LDS  R26,_i
	CP   R30,R26
	BREQ PC+3
	JMP _0xC2
; 0000 0249                 if(j==avj){
	LDS  R30,_avj
	LDS  R26,_j
	CP   R30,R26
	BREQ PC+3
	JMP _0xC3
; 0000 024A                  if(k==avk){
	LDS  R30,_avk
	LDS  R26,_k
	CP   R30,R26
	BREQ PC+3
	JMP _0xC4
; 0000 024B                   if(l==avl){
	LDS  R30,_avl
	LDS  R26,_l
	CP   R30,R26
	BREQ PC+3
	JMP _0xC5
; 0000 024C                    if(m==avm){
	LDS  R30,_avm
	CP   R30,R4
	BREQ PC+3
	JMP _0xC6
; 0000 024D                     if(n==avn){
	LDS  R30,_avn
	CP   R30,R7
	BREQ PC+3
	JMP _0xC7
; 0000 024E                      if(o==avo){
	LDS  R30,_avo
	LDS  R26,_o
	CP   R30,R26
	BREQ PC+3
	JMP _0xC8
; 0000 024F                       if(p==avp){
	LDS  R30,_avp
	LDS  R26,_p
	CP   R30,R26
	BREQ PC+3
	JMP _0xC9
; 0000 0250                        if(q==avq){
	LDS  R30,_avq
	LDS  R26,_q
	CP   R30,R26
	BREQ PC+3
	JMP _0xCA
; 0000 0251 
; 0000 0252                       license=1;
	LDI  R26,LOW(_license)
	LDI  R27,HIGH(_license)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
; 0000 0253 
; 0000 0254                       lcd_clear();
	CALL _lcd_clear
; 0000 0255 
; 0000 0256                       lcd_gotoxy(5,0);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x2A
; 0000 0257                       lcd_puts("Activated!");
	__POINTW1MN _0x26,65
	CALL SUBOPT_0x6
; 0000 0258 
; 0000 0259                       lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 025A                       lcd_puts("Thanks you for using");
	__POINTW1MN _0x26,76
	CALL SUBOPT_0x6
; 0000 025B 
; 0000 025C                       lcd_gotoxy(2,2);
	CALL SUBOPT_0x2B
; 0000 025D                       lcd_puts("this product !");
	__POINTW1MN _0x26,97
	CALL SUBOPT_0x6
; 0000 025E 
; 0000 025F                       lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 0260                       lcd_puts("Silicon-Source HW&SW");
	__POINTW1MN _0x26,112
	CALL SUBOPT_0x6
; 0000 0261 
; 0000 0262 
; 0000 0263                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xCC
	SBIC 0x13,0
	RJMP _0xCB
_0xCC:
; 0000 0264                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 0265                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xCF
	SBIC 0x13,0
	RJMP _0xCE
_0xCF:
; 0000 0266                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 0267                       }
; 0000 0268                       }
_0xCE:
; 0000 0269 
; 0000 026A                        if(PINC.1!=1||PINC.0!=1){
_0xCB:
	SBIS 0x13,1
	RJMP _0xD2
	SBIC 0x13,0
	RJMP _0xD1
_0xD2:
; 0000 026B                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 026C                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xD5
	SBIC 0x13,0
	RJMP _0xD4
_0xD5:
; 0000 026D                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 026E                       }
; 0000 026F                       }
_0xD4:
; 0000 0270 
; 0000 0271 
; 0000 0272                        if(PINC.1!=1||PINC.0!=1){
_0xD1:
	SBIS 0x13,1
	RJMP _0xD8
	SBIC 0x13,0
	RJMP _0xD7
_0xD8:
; 0000 0273                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 0274                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xDB
	SBIC 0x13,0
	RJMP _0xDA
_0xDB:
; 0000 0275                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 0276                       }
; 0000 0277                       }
_0xDA:
; 0000 0278 
; 0000 0279                        if(PINC.1!=1||PINC.0!=1){
_0xD7:
	SBIS 0x13,1
	RJMP _0xDE
	SBIC 0x13,0
	RJMP _0xDD
_0xDE:
; 0000 027A                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 027B                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xE1
	SBIC 0x13,0
	RJMP _0xE0
_0xE1:
; 0000 027C                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 027D                       }
; 0000 027E                       }
_0xE0:
; 0000 027F 
; 0000 0280 
; 0000 0281                        if(PINC.1!=1||PINC.0!=1){
_0xDD:
	SBIS 0x13,1
	RJMP _0xE4
	SBIC 0x13,0
	RJMP _0xE3
_0xE4:
; 0000 0282                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 0283                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xE7
	SBIC 0x13,0
	RJMP _0xE6
_0xE7:
; 0000 0284                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 0285                       }
; 0000 0286                       }
_0xE6:
; 0000 0287 
; 0000 0288 
; 0000 0289                        if(PINC.1!=1||PINC.0!=1){
_0xE3:
	SBIS 0x13,1
	RJMP _0xEA
	SBIC 0x13,0
	RJMP _0xE9
_0xEA:
; 0000 028A                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 028B                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xED
	SBIC 0x13,0
	RJMP _0xEC
_0xED:
; 0000 028C                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 028D                       }
; 0000 028E                       }
_0xEC:
; 0000 028F 
; 0000 0290 
; 0000 0291                        if(PINC.1!=1||PINC.0!=1){
_0xE9:
	SBIS 0x13,1
	RJMP _0xF0
	SBIC 0x13,0
	RJMP _0xEF
_0xF0:
; 0000 0292                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 0293                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xF3
	SBIC 0x13,0
	RJMP _0xF2
_0xF3:
; 0000 0294                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 0295                       }
; 0000 0296                       }
_0xF2:
; 0000 0297 
; 0000 0298 
; 0000 0299                        if(PINC.1!=1||PINC.0!=1){
_0xEF:
	SBIS 0x13,1
	RJMP _0xF6
	SBIC 0x13,0
	RJMP _0xF5
_0xF6:
; 0000 029A                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 029B                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xF9
	SBIC 0x13,0
	RJMP _0xF8
_0xF9:
; 0000 029C                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 029D                       }
; 0000 029E                       }
_0xF8:
; 0000 029F 
; 0000 02A0 
; 0000 02A1                        if(PINC.1!=1||PINC.0!=1){
_0xF5:
	SBIS 0x13,1
	RJMP _0xFC
	SBIC 0x13,0
	RJMP _0xFB
_0xFC:
; 0000 02A2                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 02A3                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0xFF
	SBIC 0x13,0
	RJMP _0xFE
_0xFF:
; 0000 02A4                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 02A5                       }
; 0000 02A6                       }
_0xFE:
; 0000 02A7 
; 0000 02A8 
; 0000 02A9                        if(PINC.1!=1||PINC.0!=1){
_0xFB:
	SBIS 0x13,1
	RJMP _0x102
	SBIC 0x13,0
	RJMP _0x101
_0x102:
; 0000 02AA                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 02AB                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0x105
	SBIC 0x13,0
	RJMP _0x104
_0x105:
; 0000 02AC                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 02AD                       }
; 0000 02AE                       }
_0x104:
; 0000 02AF 
; 0000 02B0 
; 0000 02B1                        if(PINC.1!=1||PINC.0!=1){
_0x101:
	SBIS 0x13,1
	RJMP _0x108
	SBIC 0x13,0
	RJMP _0x107
_0x108:
; 0000 02B2                        delay_ms(100);
	CALL SUBOPT_0x2D
; 0000 02B3                       if(PINC.1!=1||PINC.0!=1){
	SBIS 0x13,1
	RJMP _0x10B
	SBIC 0x13,0
	RJMP _0x10A
_0x10B:
; 0000 02B4                       delay_ms(250);
	CALL SUBOPT_0x2E
; 0000 02B5                       }
; 0000 02B6                       }
_0x10A:
; 0000 02B7 
; 0000 02B8 
; 0000 02B9 
; 0000 02BA 
; 0000 02BB 
; 0000 02BC 
; 0000 02BD 
; 0000 02BE        }
_0x107:
; 0000 02BF        }
_0xCA:
; 0000 02C0        }
_0xC9:
; 0000 02C1        }
_0xC8:
; 0000 02C2        }
_0xC7:
; 0000 02C3        }
_0xC6:
; 0000 02C4        }
_0xC5:
; 0000 02C5        }
_0xC4:
; 0000 02C6        }
_0xC3:
; 0000 02C7        }
_0xC2:
; 0000 02C8        }
_0xC1:
; 0000 02C9        }
_0xC0:
; 0000 02CA        }
_0xBF:
; 0000 02CB        }
_0xBE:
; 0000 02CC        }
_0xBD:
; 0000 02CD        }
_0xBC:
; 0000 02CE        }
_0xBB:
; 0000 02CF   }
_0xBA:
; 0000 02D0 
; 0000 02D1 
; 0000 02D2   }
_0xB6:
	RJMP _0x22
_0x24:
; 0000 02D3 
; 0000 02D4 
; 0000 02D5 
; 0000 02D6 
; 0000 02D7 
; 0000 02D8 if(setup==1){
	LDI  R30,LOW(1)
	CP   R30,R11
	BREQ PC+3
	JMP _0x10D
; 0000 02D9 setup=0;
	CLR  R11
; 0000 02DA lcd_clear();
	CALL _lcd_clear
; 0000 02DB lcd_gotoxy(0,0);
	CALL SUBOPT_0x10
; 0000 02DC lcd_puts("Digital dosimeter v2");
	__POINTW1MN _0x26,133
	CALL SUBOPT_0x6
; 0000 02DD lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 02DE lcd_puts("Loading, please wait");
	__POINTW1MN _0x26,154
	CALL SUBOPT_0x6
; 0000 02DF lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 02E0 lcd_puts("(c) Jiri Cech 8/2013");
	__POINTW1MN _0x26,175
	CALL SUBOPT_0x6
; 0000 02E1 
; 0000 02E2 delay_ms(200);
	CALL SUBOPT_0x2F
; 0000 02E3 lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 02E4 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02E5 
; 0000 02E6 delay_ms(200);
; 0000 02E7 lcd_gotoxy(1,1);
	CALL SUBOPT_0x1A
; 0000 02E8 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02E9 
; 0000 02EA 
; 0000 02EB delay_ms(200);
; 0000 02EC lcd_gotoxy(2,1);
	CALL SUBOPT_0x1B
; 0000 02ED lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02EE 
; 0000 02EF delay_ms(200);
; 0000 02F0 lcd_gotoxy(3,1);
	CALL SUBOPT_0x1C
; 0000 02F1 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02F2 
; 0000 02F3 delay_ms(200);
; 0000 02F4 lcd_gotoxy(4,1);
	CALL SUBOPT_0x11
; 0000 02F5 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02F6 
; 0000 02F7 delay_ms(200);
; 0000 02F8 lcd_gotoxy(5,1);
	CALL SUBOPT_0x1D
; 0000 02F9 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02FA 
; 0000 02FB delay_ms(200);
; 0000 02FC lcd_gotoxy(6,1);
	CALL SUBOPT_0x1E
; 0000 02FD lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 02FE 
; 0000 02FF delay_ms(200);
; 0000 0300 lcd_gotoxy(7,1);
	CALL SUBOPT_0x1F
; 0000 0301 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0302 
; 0000 0303 delay_ms(200);
; 0000 0304 lcd_gotoxy(8,1);
	CALL SUBOPT_0x20
; 0000 0305 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0306 
; 0000 0307 delay_ms(200);
; 0000 0308 lcd_gotoxy(9,1);
	CALL SUBOPT_0x12
; 0000 0309 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 030A 
; 0000 030B delay_ms(200);
; 0000 030C lcd_gotoxy(10,1);
	CALL SUBOPT_0x21
; 0000 030D lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 030E 
; 0000 030F delay_ms(200);
; 0000 0310 lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0311 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0312 
; 0000 0313 delay_ms(200);
; 0000 0314 lcd_gotoxy(12,1);
	CALL SUBOPT_0x23
; 0000 0315 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0316 
; 0000 0317 delay_ms(200);
; 0000 0318 lcd_gotoxy(13,1);
	CALL SUBOPT_0x24
; 0000 0319 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 031A 
; 0000 031B delay_ms(200);
; 0000 031C lcd_gotoxy(14,1);
	CALL SUBOPT_0x13
; 0000 031D lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 031E 
; 0000 031F delay_ms(200);
; 0000 0320 lcd_gotoxy(15,1);
	CALL SUBOPT_0x25
; 0000 0321 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0322 
; 0000 0323 delay_ms(200);
; 0000 0324 lcd_gotoxy(16,1);
	CALL SUBOPT_0x26
; 0000 0325 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 0326 
; 0000 0327 delay_ms(200);
; 0000 0328 lcd_gotoxy(17,1);
	CALL SUBOPT_0x27
; 0000 0329 lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 032A 
; 0000 032B delay_ms(200);
; 0000 032C lcd_gotoxy(18,1);
	CALL SUBOPT_0x28
; 0000 032D lcd_putchar(0xFF);
	CALL SUBOPT_0x30
; 0000 032E 
; 0000 032F delay_ms(200);
; 0000 0330 lcd_gotoxy(19,1);
	CALL SUBOPT_0x29
; 0000 0331 lcd_putchar(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 0332 
; 0000 0333 lcd_clear();
	CALL _lcd_clear
; 0000 0334 
; 0000 0335 
; 0000 0336 
; 0000 0337 
; 0000 0338 lcd_gotoxy(10,1);
	CALL SUBOPT_0x21
; 0000 0339 lcd_puts("|");
	__POINTW1MN _0x26,196
	CALL SUBOPT_0x6
; 0000 033A 
; 0000 033B lcd_gotoxy(17,1);
	CALL SUBOPT_0x27
; 0000 033C lcd_puts("cpm");
	__POINTW1MN _0x26,198
	CALL SUBOPT_0x6
; 0000 033D 
; 0000 033E lcd_gotoxy(0,0);
	CALL SUBOPT_0x10
; 0000 033F lcd_puts("UPDATE:");
	__POINTW1MN _0x26,202
	CALL SUBOPT_0x6
; 0000 0340 
; 0000 0341 lcd_gotoxy(9,0);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x2A
; 0000 0342 lcd_puts("s");
	__POINTW1MN _0x26,210
	CALL SUBOPT_0x6
; 0000 0343 
; 0000 0344 lcd_gotoxy(10,0);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x2A
; 0000 0345 lcd_puts("|");
	__POINTW1MN _0x26,212
	CALL SUBOPT_0x6
; 0000 0346 
; 0000 0347 
; 0000 0348 lcd_gotoxy(17,2);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x31
; 0000 0349 lcd_puts("cph");
	__POINTW1MN _0x26,214
	CALL SUBOPT_0x6
; 0000 034A 
; 0000 034B lcd_gotoxy(10,2);
	LDI  R30,LOW(10)
	CALL SUBOPT_0x31
; 0000 034C lcd_puts("|");
	__POINTW1MN _0x26,218
	CALL SUBOPT_0x6
; 0000 034D 
; 0000 034E 
; 0000 034F 
; 0000 0350 lcd_gotoxy(5,3);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x32
; 0000 0351 lcd_puts("|");
	__POINTW1MN _0x26,220
	CALL SUBOPT_0x6
; 0000 0352 
; 0000 0353 
; 0000 0354 lcd_gotoxy(17,3);
	LDI  R30,LOW(17)
	CALL SUBOPT_0x32
; 0000 0355 lcd_puts("ctt");
	__POINTW1MN _0x26,222
	CALL SUBOPT_0x6
; 0000 0356 
; 0000 0357 lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0358 lcd_puts("-----");
	__POINTW1MN _0x26,226
	CALL SUBOPT_0x6
; 0000 0359 
; 0000 035A lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 035B lcd_puts("-----");
	__POINTW1MN _0x26,232
	CALL SUBOPT_0x6
; 0000 035C 
; 0000 035D lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 035E lcd_puts("----");
	__POINTW1MN _0x26,238
	CALL SUBOPT_0x6
; 0000 035F 
; 0000 0360 lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0361 lcd_puts("-----");
	__POINTW1MN _0x26,243
	CALL SUBOPT_0x6
; 0000 0362 
; 0000 0363 lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 0364 lcd_puts("-----");
	__POINTW1MN _0x26,249
	CALL SUBOPT_0x6
; 0000 0365 
; 0000 0366 lcd_gotoxy(6,3);
	CALL SUBOPT_0x5
; 0000 0367 lcd_puts("----------");
	__POINTW1MN _0x26,255
	CALL SUBOPT_0x6
; 0000 0368 
; 0000 0369 s=0;
	CLR  R5
; 0000 036A five=0;
	CLR  R6
; 0000 036B }
; 0000 036C 
; 0000 036D if(mrhset==0){
_0x10D:
	TST  R10
	BRNE _0x10E
; 0000 036E lcd_gotoxy(6,1);
	CALL SUBOPT_0x1E
; 0000 036F lcd_puts("uR/h");
	__POINTW1MN _0x26,266
	CALL SUBOPT_0x6
; 0000 0370 }
; 0000 0371 
; 0000 0372 if(mrhset==1){
_0x10E:
	LDI  R30,LOW(1)
	CP   R30,R10
	BRNE _0x10F
; 0000 0373 lcd_gotoxy(6,1);
	CALL SUBOPT_0x1E
; 0000 0374 lcd_puts("mR/h");
	__POINTW1MN _0x26,271
	CALL SUBOPT_0x6
; 0000 0375 }
; 0000 0376 
; 0000 0377 if(mrhsetfive==0){
_0x10F:
	TST  R9
	BRNE _0x110
; 0000 0378 lcd_gotoxy(6,2);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x31
; 0000 0379 lcd_puts("uR/h");
	__POINTW1MN _0x26,276
	CALL SUBOPT_0x6
; 0000 037A }
; 0000 037B 
; 0000 037C if(mrhsetfive==1){
_0x110:
	LDI  R30,LOW(1)
	CP   R30,R9
	BRNE _0x111
; 0000 037D lcd_gotoxy(6,2);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x31
; 0000 037E lcd_puts("mR/h");
	__POINTW1MN _0x26,281
	CALL SUBOPT_0x6
; 0000 037F }
; 0000 0380 
; 0000 0381 
; 0000 0382 
; 0000 0383 
; 0000 0384 
; 0000 0385 
; 0000 0386 if(setup!=1){
_0x111:
	LDI  R30,LOW(1)
	CP   R30,R11
	BRNE PC+3
	JMP _0x112
; 0000 0387 if(five==5){
	LDI  R30,LOW(5)
	CP   R30,R6
	BREQ PC+3
	JMP _0x113
; 0000 0388 five=0;
	CLR  R6
; 0000 0389 lcd_gotoxy(6,1);
	CALL SUBOPT_0x1E
; 0000 038A lcd_puts("uR/h");
	__POINTW1MN _0x26,286
	CALL SUBOPT_0x6
; 0000 038B urhfive=cpfive*38;
	LDS  R30,_cpfive
	LDS  R31,_cpfive+1
	LDS  R22,_cpfive+2
	LDS  R23,_cpfive+3
	CALL SUBOPT_0x33
	CALL SUBOPT_0x34
; 0000 038C urhfive=urhfive*12;
	CALL SUBOPT_0x35
	__GETD2N 0xC
	CALL __MULD12U
	CALL SUBOPT_0x34
; 0000 038D cpfive=0;
	LDI  R30,LOW(0)
	STS  _cpfive,R30
	STS  _cpfive+1,R30
	STS  _cpfive+2,R30
	STS  _cpfive+3,R30
; 0000 038E urhfive=urhfive/100;
	CALL SUBOPT_0x36
	CALL SUBOPT_0x37
	CALL SUBOPT_0x34
; 0000 038F ltoa(urhfive,urhfivec);
	CALL SUBOPT_0x35
	CALL __PUTPARD1
	LDI  R30,LOW(_urhfivec)
	LDI  R31,HIGH(_urhfivec)
	CALL SUBOPT_0x38
; 0000 0390  if(urhfive<10){
	CALL SUBOPT_0x39
	BRSH _0x114
; 0000 0391     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 0392     lcd_puts("0000");
	__POINTW1MN _0x26,291
	CALL SUBOPT_0x6
; 0000 0393     lcd_gotoxy(4,2);
	LDI  R30,LOW(4)
	CALL SUBOPT_0x31
; 0000 0394     lcd_puts(urhfivec);
	CALL SUBOPT_0x3A
; 0000 0395 
; 0000 0396     }
; 0000 0397 
; 0000 0398     if(urhfive<100 && urhfive>9){
_0x114:
	CALL SUBOPT_0x3B
	BRSH _0x116
	CALL SUBOPT_0x39
	BRSH _0x117
_0x116:
	RJMP _0x115
_0x117:
; 0000 0399     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 039A     lcd_puts("000");
	__POINTW1MN _0x26,296
	CALL SUBOPT_0x6
; 0000 039B     lcd_gotoxy(3,2);
	LDI  R30,LOW(3)
	CALL SUBOPT_0x31
; 0000 039C     lcd_puts(urhfivec);
	CALL SUBOPT_0x3A
; 0000 039D     }
; 0000 039E 
; 0000 039F     if(urhfive<1000 && urhfive>99){
_0x115:
	CALL SUBOPT_0x3C
	BRSH _0x119
	CALL SUBOPT_0x3B
	BRSH _0x11A
_0x119:
	RJMP _0x118
_0x11A:
; 0000 03A0     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 03A1     lcd_puts("00");
	__POINTW1MN _0x26,300
	CALL SUBOPT_0x6
; 0000 03A2     lcd_gotoxy(2,2);
	CALL SUBOPT_0x2B
; 0000 03A3     lcd_puts(urhfivec);
	CALL SUBOPT_0x3A
; 0000 03A4     }
; 0000 03A5 
; 0000 03A6     if(urhfive<10000 && urhfive>999){
_0x118:
	CALL SUBOPT_0x3D
	BRSH _0x11C
	CALL SUBOPT_0x3C
	BRSH _0x11D
_0x11C:
	RJMP _0x11B
_0x11D:
; 0000 03A7     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 03A8     lcd_puts("0");
	__POINTW1MN _0x26,303
	CALL SUBOPT_0x6
; 0000 03A9      lcd_gotoxy(1,2);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x31
; 0000 03AA     lcd_puts(urhfivec);
	CALL SUBOPT_0x3A
; 0000 03AB     }
; 0000 03AC 
; 0000 03AD     if(urhfive>9999){
_0x11B:
	CALL SUBOPT_0x3D
	BRLO _0x11E
; 0000 03AE     lcd_gotoxy(0,2);
	CALL SUBOPT_0x14
; 0000 03AF     lcd_puts(urhfivec);
	CALL SUBOPT_0x3A
; 0000 03B0     }
; 0000 03B1 
; 0000 03B2 
; 0000 03B3 
; 0000 03B4      if(urh>99999){
_0x11E:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	BRSH PC+3
	JMP _0x11F
; 0000 03B5     mrhset=1;
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 03B6 
; 0000 03B7     mrhfive=urhfive/1000;
	CALL SUBOPT_0x40
	STS  _mrhfive,R30
	STS  _mrhfive+1,R31
	STS  _mrhfive+2,R22
	STS  _mrhfive+3,R23
; 0000 03B8     ltoa(mrhfive,mrhfivec);
	CALL __PUTPARD1
	LDI  R30,LOW(_mrhfivec)
	LDI  R31,HIGH(_mrhfivec)
	CALL SUBOPT_0x38
; 0000 03B9 
; 0000 03BA     if(mrhfive<10){
	CALL SUBOPT_0x41
	CALL SUBOPT_0x42
	BRSH _0x120
; 0000 03BB     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03BC     lcd_puts("0000");
	__POINTW1MN _0x26,305
	CALL SUBOPT_0x6
; 0000 03BD     lcd_gotoxy(4,1);
	CALL SUBOPT_0x11
; 0000 03BE     lcd_puts(mrhfivec);
	CALL SUBOPT_0x43
; 0000 03BF     }
; 0000 03C0 
; 0000 03C1     if(mrhfive<100 && mrhfive>9){
_0x120:
	CALL SUBOPT_0x44
	BRSH _0x122
	CALL SUBOPT_0x41
	CALL SUBOPT_0x42
	BRSH _0x123
_0x122:
	RJMP _0x121
_0x123:
; 0000 03C2     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03C3     lcd_puts("000");
	__POINTW1MN _0x26,310
	CALL SUBOPT_0x6
; 0000 03C4     lcd_gotoxy(3,1);
	CALL SUBOPT_0x1C
; 0000 03C5     lcd_puts(mrhfivec);
	CALL SUBOPT_0x43
; 0000 03C6     }
; 0000 03C7 
; 0000 03C8     if(mrhfive<1000 && mrhfive>99){
_0x121:
	CALL SUBOPT_0x45
	BRSH _0x125
	CALL SUBOPT_0x44
	BRSH _0x126
_0x125:
	RJMP _0x124
_0x126:
; 0000 03C9     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03CA     lcd_puts("00");
	__POINTW1MN _0x26,314
	CALL SUBOPT_0x6
; 0000 03CB      lcd_gotoxy(2,1);
	CALL SUBOPT_0x1B
; 0000 03CC     lcd_puts(mrhfivec);
	CALL SUBOPT_0x43
; 0000 03CD     }
; 0000 03CE 
; 0000 03CF     if(mrhfive<10000 && mrhfive>999){
_0x124:
	CALL SUBOPT_0x46
	BRSH _0x128
	CALL SUBOPT_0x45
	BRSH _0x129
_0x128:
	RJMP _0x127
_0x129:
; 0000 03D0     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03D1     lcd_puts("0");
	__POINTW1MN _0x26,317
	CALL SUBOPT_0x6
; 0000 03D2      lcd_gotoxy(1,1);
	CALL SUBOPT_0x1A
; 0000 03D3     lcd_puts(mrhfivec);
	CALL SUBOPT_0x43
; 0000 03D4     }
; 0000 03D5 
; 0000 03D6     if(mrhfive<100000 && mrhfive>9999){
_0x127:
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3F
	BRSH _0x12B
	CALL SUBOPT_0x46
	BRSH _0x12C
_0x12B:
	RJMP _0x12A
_0x12C:
; 0000 03D7     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03D8     lcd_puts(mrhfivec);
	CALL SUBOPT_0x43
; 0000 03D9     }
; 0000 03DA 
; 0000 03DB     if(mrhfive>99999){
_0x12A:
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3F
	BRLO _0x12D
; 0000 03DC     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 03DD     lcd_puts("-over-");
	__POINTW1MN _0x26,319
	CALL SUBOPT_0x6
; 0000 03DE     }
; 0000 03DF     mrhset=0;
_0x12D:
	CLR  R10
; 0000 03E0     }
; 0000 03E1 
; 0000 03E2 
; 0000 03E3 
; 0000 03E4     if(urhfive<30){
_0x11F:
	CALL SUBOPT_0x47
	BRSH _0x12E
; 0000 03E5     lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 03E6     lcd_puts("NORM.");
	__POINTW1MN _0x26,326
	CALL SUBOPT_0x6
; 0000 03E7     }
; 0000 03E8 
; 0000 03E9      if(urhfive>29 && urhfive<1000){
_0x12E:
	CALL SUBOPT_0x47
	BRLO _0x130
	CALL SUBOPT_0x3C
	BRLO _0x131
_0x130:
	RJMP _0x12F
_0x131:
; 0000 03EA     lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 03EB     lcd_puts("GOOD ");
	__POINTW1MN _0x26,332
	CALL SUBOPT_0x6
; 0000 03EC     }
; 0000 03ED 
; 0000 03EE     if(urhfive>1000){
_0x12F:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x48
	BRLO _0x132
; 0000 03EF     n=urhfive/1000;
	CALL SUBOPT_0x40
	MOV  R7,R30
; 0000 03F0 
; 0000 03F1     if(n>1,9){
	MOV  R26,R7
	LDI  R30,LOW(1)
	CALL __GTB12U
; 0000 03F2     itoa(n,nc);
	MOV  R30,R7
	CALL SUBOPT_0x17
	LDI  R30,LOW(_nc)
	LDI  R31,HIGH(_nc)
	CALL SUBOPT_0x18
; 0000 03F3 
; 0000 03F4     if(n>99){
	LDI  R30,LOW(99)
	CP   R30,R7
	BRSH _0x134
; 0000 03F5     lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 03F6     lcd_puts(nc);
	CALL SUBOPT_0x49
; 0000 03F7     }
; 0000 03F8 
; 0000 03F9     if(n>9 && n<100){
_0x134:
	LDI  R30,LOW(9)
	CP   R30,R7
	BRSH _0x136
	LDI  R30,LOW(100)
	CP   R7,R30
	BRLO _0x137
_0x136:
	RJMP _0x135
_0x137:
; 0000 03FA     lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 03FB     lcd_puts("0");
	__POINTW1MN _0x26,338
	CALL SUBOPT_0x6
; 0000 03FC     lcd_gotoxy(1,3);
	LDI  R30,LOW(1)
	CALL SUBOPT_0x32
; 0000 03FD     lcd_puts(nc);
	CALL SUBOPT_0x49
; 0000 03FE     }
; 0000 03FF 
; 0000 0400     if(n<9){
_0x135:
	LDI  R30,LOW(9)
	CP   R7,R30
	BRSH _0x138
; 0000 0401     lcd_gotoxy(0,3);
	CALL SUBOPT_0x2C
; 0000 0402     lcd_puts("00");
	__POINTW1MN _0x26,340
	CALL SUBOPT_0x6
; 0000 0403     lcd_gotoxy(2,3);
	CALL SUBOPT_0x15
; 0000 0404     lcd_puts(nc);
	CALL SUBOPT_0x49
; 0000 0405     }
; 0000 0406 
; 0000 0407     lcd_gotoxy(4,3);
_0x138:
	LDI  R30,LOW(4)
	CALL SUBOPT_0x32
; 0000 0408     lcd_puts("x");
	__POINTW1MN _0x26,343
	CALL SUBOPT_0x6
; 0000 0409     }
; 0000 040A     }
; 0000 040B 
; 0000 040C 
; 0000 040D 
; 0000 040E 
; 0000 040F 
; 0000 0410 }
_0x132:
; 0000 0411 
; 0000 0412 s++;
_0x113:
	INC  R5
; 0000 0413 sm=60-s;
	MOV  R30,R5
	LDI  R31,0
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOV  R8,R30
; 0000 0414 ltoa(sm,sc);
	MOV  R30,R8
	LDI  R31,0
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x38
; 0000 0415 ltoa(cpm,cpmc);
	CALL SUBOPT_0x4A
	CALL __PUTPARD1
	LDI  R30,LOW(_cpmc)
	LDI  R31,HIGH(_cpmc)
	CALL SUBOPT_0x38
; 0000 0416 ltoa(cph,cphc);
	LDS  R30,_cph
	LDS  R31,_cph+1
	LDS  R22,_cph+2
	LDS  R23,_cph+3
	CALL __PUTPARD1
	LDI  R30,LOW(_cphc)
	LDI  R31,HIGH(_cphc)
	CALL SUBOPT_0x38
; 0000 0417 
; 0000 0418 
; 0000 0419 if(sm>9){
	LDI  R30,LOW(9)
	CP   R30,R8
	BRSH _0x139
; 0000 041A lcd_gotoxy(7,0);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x2A
; 0000 041B lcd_puts(sc);
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x6
; 0000 041C }
; 0000 041D 
; 0000 041E if(sm<10){
_0x139:
	LDI  R30,LOW(10)
	CP   R8,R30
	BRSH _0x13A
; 0000 041F lcd_gotoxy(7,0);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x2A
; 0000 0420 lcd_puts("0");
	__POINTW1MN _0x26,345
	CALL SUBOPT_0x6
; 0000 0421 lcd_gotoxy(8,0);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x2A
; 0000 0422 lcd_puts(sc);
	LDI  R30,LOW(_sc)
	LDI  R31,HIGH(_sc)
	CALL SUBOPT_0x6
; 0000 0423 }
; 0000 0424 
; 0000 0425 
; 0000 0426 
; 0000 0427 if(s==60){
_0x13A:
	LDI  R30,LOW(60)
	CP   R30,R5
	BREQ PC+3
	JMP _0x13B
; 0000 0428 
; 0000 0429 
; 0000 042A 
; 0000 042B s=0;
	CLR  R5
; 0000 042C m++;
	INC  R4
; 0000 042D 
; 0000 042E 
; 0000 042F     if(cpm<10){
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x42
	BRSH _0x13C
; 0000 0430     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0431     lcd_puts("0000");
	__POINTW1MN _0x26,347
	CALL SUBOPT_0x6
; 0000 0432     lcd_gotoxy(15,1);
	CALL SUBOPT_0x25
; 0000 0433     lcd_puts(cpmc);
	CALL SUBOPT_0x4C
; 0000 0434     }
; 0000 0435 
; 0000 0436     if(cpm<100 && cpm>9){
_0x13C:
	CALL SUBOPT_0x4D
	BRSH _0x13E
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x42
	BRSH _0x13F
_0x13E:
	RJMP _0x13D
_0x13F:
; 0000 0437     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0438     lcd_puts("000");
	__POINTW1MN _0x26,352
	CALL SUBOPT_0x6
; 0000 0439     lcd_gotoxy(14,1);
	CALL SUBOPT_0x13
; 0000 043A     lcd_puts(cpmc);
	CALL SUBOPT_0x4C
; 0000 043B     }
; 0000 043C 
; 0000 043D     if(cpm<1000 && cpm>99){
_0x13D:
	CALL SUBOPT_0x4E
	BRSH _0x141
	CALL SUBOPT_0x4D
	BRSH _0x142
_0x141:
	RJMP _0x140
_0x142:
; 0000 043E     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 043F     lcd_puts("00");
	__POINTW1MN _0x26,356
	CALL SUBOPT_0x6
; 0000 0440      lcd_gotoxy(13,1);
	CALL SUBOPT_0x24
; 0000 0441     lcd_puts(cpmc);
	CALL SUBOPT_0x4C
; 0000 0442     }
; 0000 0443 
; 0000 0444     if(cpm<10000 && cpm>999){
_0x140:
	CALL SUBOPT_0x4F
	BRSH _0x144
	CALL SUBOPT_0x4E
	BRSH _0x145
_0x144:
	RJMP _0x143
_0x145:
; 0000 0445     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0446     lcd_puts("0");
	__POINTW1MN _0x26,359
	CALL SUBOPT_0x6
; 0000 0447      lcd_gotoxy(12,1);
	CALL SUBOPT_0x23
; 0000 0448     lcd_puts(cpmc);
	CALL SUBOPT_0x4C
; 0000 0449     }
; 0000 044A 
; 0000 044B     if(cpm>9999){
_0x143:
	CALL SUBOPT_0x4F
	BRLO _0x146
; 0000 044C     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 044D     lcd_puts(cpmc);
	CALL SUBOPT_0x4C
; 0000 044E     }
; 0000 044F 
; 0000 0450     if(cpm>99999){
_0x146:
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x3F
	BRLO _0x147
; 0000 0451     lcd_gotoxy(11,1);
	CALL SUBOPT_0x22
; 0000 0452     lcd_puts("-over-");
	__POINTW1MN _0x26,361
	CALL SUBOPT_0x6
; 0000 0453     }
; 0000 0454 
; 0000 0455     urh=cpm*38;
_0x147:
	CALL SUBOPT_0x4A
	CALL SUBOPT_0x33
	CALL SUBOPT_0x50
; 0000 0456     urh=urh/100;
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x37
	CALL SUBOPT_0x50
; 0000 0457     ltoa(urh,urhc);
	LDS  R30,_urh
	LDS  R31,_urh+1
	LDS  R22,_urh+2
	LDS  R23,_urh+3
	CALL __PUTPARD1
	LDI  R30,LOW(_urhc)
	LDI  R31,HIGH(_urhc)
	CALL SUBOPT_0x38
; 0000 0458 
; 0000 0459 
; 0000 045A 
; 0000 045B      if(urh<9){
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x51
	BRSH _0x148
; 0000 045C     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 045D     lcd_puts("0000");
	__POINTW1MN _0x26,368
	CALL SUBOPT_0x6
; 0000 045E     lcd_gotoxy(4,1);
	CALL SUBOPT_0x11
; 0000 045F     lcd_puts(urhc);
	CALL SUBOPT_0x52
; 0000 0460     }
; 0000 0461 
; 0000 0462     if(urh<99 && urh>10){
_0x148:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x53
	BRSH _0x14A
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x54
	BRSH _0x14B
_0x14A:
	RJMP _0x149
_0x14B:
; 0000 0463     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0464     lcd_puts("000");
	__POINTW1MN _0x26,373
	CALL SUBOPT_0x6
; 0000 0465     lcd_gotoxy(3,1);
	CALL SUBOPT_0x1C
; 0000 0466     lcd_puts(urhc);
	CALL SUBOPT_0x52
; 0000 0467     }
; 0000 0468 
; 0000 0469     if(urh<999 && urh>100){
_0x149:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x55
	BRSH _0x14D
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x56
	BRSH _0x14E
_0x14D:
	RJMP _0x14C
_0x14E:
; 0000 046A     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 046B     lcd_puts("00");
	__POINTW1MN _0x26,377
	CALL SUBOPT_0x6
; 0000 046C      lcd_gotoxy(2,1);
	CALL SUBOPT_0x1B
; 0000 046D     lcd_puts(urhc);
	CALL SUBOPT_0x52
; 0000 046E     }
; 0000 046F 
; 0000 0470 
; 0000 0471     if(urh>99999){
_0x14C:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	BRSH PC+3
	JMP _0x14F
; 0000 0472     mrhset=1;
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 0473 
; 0000 0474     mrh=urh/1000;
	CALL SUBOPT_0x3E
	__GETD1N 0x3E8
	CALL __DIVD21U
	STS  _mrh,R30
	STS  _mrh+1,R31
	STS  _mrh+2,R22
	STS  _mrh+3,R23
; 0000 0475     ltoa(mrh,mrhc);
	CALL __PUTPARD1
	LDI  R30,LOW(_mrhc)
	LDI  R31,HIGH(_mrhc)
	CALL SUBOPT_0x38
; 0000 0476 
; 0000 0477     if(mrh<9){
	CALL SUBOPT_0x57
	CALL SUBOPT_0x51
	BRSH _0x150
; 0000 0478     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0479     lcd_puts("0000");
	__POINTW1MN _0x26,380
	CALL SUBOPT_0x6
; 0000 047A     lcd_gotoxy(4,1);
	CALL SUBOPT_0x11
; 0000 047B     lcd_puts(mrhc);
	CALL SUBOPT_0x58
; 0000 047C     }
; 0000 047D 
; 0000 047E     if(mrh<99 && mrh>10){
_0x150:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x53
	BRSH _0x152
	CALL SUBOPT_0x57
	CALL SUBOPT_0x54
	BRSH _0x153
_0x152:
	RJMP _0x151
_0x153:
; 0000 047F     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0480     lcd_puts("000");
	__POINTW1MN _0x26,385
	CALL SUBOPT_0x6
; 0000 0481     lcd_gotoxy(3,1);
	CALL SUBOPT_0x1C
; 0000 0482     lcd_puts(mrhc);
	CALL SUBOPT_0x58
; 0000 0483     }
; 0000 0484 
; 0000 0485     if(mrh<999 && mrh>100){
_0x151:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x55
	BRSH _0x155
	CALL SUBOPT_0x57
	CALL SUBOPT_0x56
	BRSH _0x156
_0x155:
	RJMP _0x154
_0x156:
; 0000 0486     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0487     lcd_puts("00");
	__POINTW1MN _0x26,389
	CALL SUBOPT_0x6
; 0000 0488      lcd_gotoxy(2,1);
	CALL SUBOPT_0x1B
; 0000 0489     lcd_puts(mrhc);
	CALL SUBOPT_0x58
; 0000 048A     }
; 0000 048B 
; 0000 048C     if(mrh<9999 && mrh>1000){
_0x154:
	CALL SUBOPT_0x57
	__CPD2N 0x270F
	BRSH _0x158
	CALL SUBOPT_0x57
	CALL SUBOPT_0x48
	BRSH _0x159
_0x158:
	RJMP _0x157
_0x159:
; 0000 048D     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 048E     lcd_puts("0");
	__POINTW1MN _0x26,392
	CALL SUBOPT_0x6
; 0000 048F      lcd_gotoxy(1,1);
	CALL SUBOPT_0x1A
; 0000 0490     lcd_puts(mrhc);
	CALL SUBOPT_0x58
; 0000 0491     }
; 0000 0492 
; 0000 0493     if(mrh>9999 && mrh<10000){
_0x157:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x59
	BRLO _0x15B
	BRLO _0x15C
_0x15B:
	RJMP _0x15A
_0x15C:
; 0000 0494     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 0495     lcd_puts(mrhc);
	CALL SUBOPT_0x58
; 0000 0496     }
; 0000 0497 
; 0000 0498     if(mrh>99999){
_0x15A:
	CALL SUBOPT_0x57
	CALL SUBOPT_0x3F
	BRLO _0x15D
; 0000 0499     lcd_gotoxy(0,1);
	CALL SUBOPT_0x19
; 0000 049A     lcd_puts("-over-");
	__POINTW1MN _0x26,394
	CALL SUBOPT_0x6
; 0000 049B     }
; 0000 049C 
; 0000 049D     mrhset=0;
_0x15D:
	CLR  R10
; 0000 049E 
; 0000 049F     }
; 0000 04A0 
; 0000 04A1     cpm=0;
_0x14F:
	CALL SUBOPT_0x5A
; 0000 04A2     urh=0;
	CALL SUBOPT_0x5B
; 0000 04A3 
; 0000 04A4 
; 0000 04A5 
; 0000 04A6   }
; 0000 04A7 
; 0000 04A8 if(m==60){
_0x13B:
	LDI  R30,LOW(60)
	CP   R30,R4
	BREQ PC+3
	JMP _0x15E
; 0000 04A9 m=0;
	CLR  R4
; 0000 04AA 
; 0000 04AB     if(cph<10){
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x42
	BRSH _0x15F
; 0000 04AC     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04AD     lcd_puts("0000");
	__POINTW1MN _0x26,401
	CALL SUBOPT_0x6
; 0000 04AE     lcd_gotoxy(15,2);
	LDI  R30,LOW(15)
	CALL SUBOPT_0x31
; 0000 04AF     lcd_puts(cphc);
	CALL SUBOPT_0x5D
; 0000 04B0     }
; 0000 04B1 
; 0000 04B2     if(cph<100 && cph>9){
_0x15F:
	CALL SUBOPT_0x5E
	BRSH _0x161
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x42
	BRSH _0x162
_0x161:
	RJMP _0x160
_0x162:
; 0000 04B3     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04B4     lcd_puts("000");
	__POINTW1MN _0x26,406
	CALL SUBOPT_0x6
; 0000 04B5     lcd_gotoxy(14,2);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x31
; 0000 04B6     lcd_puts(cphc);
	CALL SUBOPT_0x5D
; 0000 04B7     }
; 0000 04B8 
; 0000 04B9     if(cph<1000 && cph>99){
_0x160:
	CALL SUBOPT_0x5F
	BRSH _0x164
	CALL SUBOPT_0x5E
	BRSH _0x165
_0x164:
	RJMP _0x163
_0x165:
; 0000 04BA     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04BB     lcd_puts("00");
	__POINTW1MN _0x26,410
	CALL SUBOPT_0x6
; 0000 04BC      lcd_gotoxy(13,2);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x31
; 0000 04BD     lcd_puts(cphc);
	CALL SUBOPT_0x5D
; 0000 04BE     }
; 0000 04BF 
; 0000 04C0     if(cph<10000 && cph>999){
_0x163:
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x59
	BRSH _0x167
	CALL SUBOPT_0x5F
	BRSH _0x168
_0x167:
	RJMP _0x166
_0x168:
; 0000 04C1     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04C2     lcd_puts("0");
	__POINTW1MN _0x26,413
	CALL SUBOPT_0x6
; 0000 04C3      lcd_gotoxy(12,2);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x31
; 0000 04C4     lcd_puts(cphc);
	CALL SUBOPT_0x5D
; 0000 04C5     }
; 0000 04C6 
; 0000 04C7     if(cph>9999){
_0x166:
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x59
	BRLO _0x169
; 0000 04C8     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04C9     lcd_puts(cphc);
	CALL SUBOPT_0x5D
; 0000 04CA     }
; 0000 04CB 
; 0000 04CC     if(cph>99999){
_0x169:
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x3F
	BRLO _0x16A
; 0000 04CD     lcd_gotoxy(11,2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x31
; 0000 04CE     lcd_puts("-over-");
	__POINTW1MN _0x26,415
	CALL SUBOPT_0x6
; 0000 04CF     }
; 0000 04D0 
; 0000 04D1     }
_0x16A:
; 0000 04D2 
; 0000 04D3     cph=0;
_0x15E:
	LDI  R30,LOW(0)
	CALL SUBOPT_0x60
; 0000 04D4 
; 0000 04D5   }
; 0000 04D6   }
_0x112:
	CALL SUBOPT_0xF
	RETI

	.DSEG
_0x26:
	.BYTE 0x1A6
;
;
;
;
;
;
;
;
;
;
;
;void main(void)
; 0000 04E3 {

	.CSEG
_main:
; 0000 04E4 // Declare your local variables here
; 0000 04E5 
; 0000 04E6 // Crystal Oscillator division factor: 1
; 0000 04E7 #pragma optsize-
; 0000 04E8 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 04E9 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 04EA #ifdef _OPTIMIZE_SIZE_
; 0000 04EB #pragma optsize+
; 0000 04EC #endif
; 0000 04ED 
; 0000 04EE // Input/Output Ports initialization
; 0000 04EF // Port A initialization
; 0000 04F0 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 04F1 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 04F2 PORTA=0x00;
	OUT  0x1B,R30
; 0000 04F3 DDRA=0x00;
	OUT  0x1A,R30
; 0000 04F4 
; 0000 04F5 // Port B initialization
; 0000 04F6 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 04F7 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 04F8 PORTB=0x00;
	OUT  0x18,R30
; 0000 04F9 DDRB=0x00;
	OUT  0x17,R30
; 0000 04FA 
; 0000 04FB // Port C initialization
; 0000 04FC // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 04FD // State7=t State6=t State5=t State4=t State3=t State2=t State1=t State0=t
; 0000 04FE PORTC=0x00;
	OUT  0x15,R30
; 0000 04FF DDRC=0x00;
	OUT  0x14,R30
; 0000 0500 
; 0000 0501 // Port D initialization
; 0000 0502 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0503 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0504 PORTD=0x00;
	OUT  0x12,R30
; 0000 0505 DDRD=0x00;
	OUT  0x11,R30
; 0000 0506 
; 0000 0507 // Port E initialization
; 0000 0508 // Func2=In Func1=In Func0=In
; 0000 0509 // State2=T State1=T State0=T
; 0000 050A PORTE=0x00;
	OUT  0x7,R30
; 0000 050B DDRE=0x00;
	OUT  0x6,R30
; 0000 050C 
; 0000 050D // Timer/Counter 0 initialization
; 0000 050E // Clock source: System Clock
; 0000 050F // Clock value: Timer 0 Stopped
; 0000 0510 // Mode: Normal top=0xFF
; 0000 0511 // OC0 output: Disconnected
; 0000 0512 TCCR0=0x00;
	OUT  0x33,R30
; 0000 0513 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0514 OCR0=0x00;
	OUT  0x31,R30
; 0000 0515 
; 0000 0516 // Timer/Counter 1 initialization
; 0000 0517 // Clock source: System Clock
; 0000 0518 // Clock value: Timer1 Stopped
; 0000 0519 // Mode: Normal top=0xFFFF
; 0000 051A // OC1A output: Discon.
; 0000 051B // OC1B output: Discon.
; 0000 051C // Noise Canceler: Off
; 0000 051D // Input Capture on Falling Edge
; 0000 051E // Timer1 Overflow Interrupt: Off
; 0000 051F // Input Capture Interrupt: Off
; 0000 0520 // Compare A Match Interrupt: Off
; 0000 0521 // Compare B Match Interrupt: Off
; 0000 0522 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0523 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0524 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0525 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0526 ICR1H=0x00;
	OUT  0x25,R30
; 0000 0527 ICR1L=0x00;
	OUT  0x24,R30
; 0000 0528 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0529 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 052A OCR1BH=0x00;
	OUT  0x29,R30
; 0000 052B OCR1BL=0x00;
	OUT  0x28,R30
; 0000 052C 
; 0000 052D // Timer/Counter 2 initialization
; 0000 052E // Clock source: TOSC1 pin
; 0000 052F // Clock value: PCK2/128
; 0000 0530 // Mode: Normal top=0xFF
; 0000 0531 // OC2 output: Disconnected
; 0000 0532 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x26,R30
; 0000 0533 TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x27,R30
; 0000 0534 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x23,R30
; 0000 0535 OCR2=0x00;
	OUT  0x22,R30
; 0000 0536 
; 0000 0537 // Timer/Counter 3 initialization
; 0000 0538 // Clock value: Timer3 Stopped
; 0000 0539 // Mode: Normal top=0xFFFF
; 0000 053A // OC3A output: Discon.
; 0000 053B // OC3B output: Discon.
; 0000 053C // Noise Canceler: Off
; 0000 053D // Input Capture on Falling Edge
; 0000 053E // Timer3 Overflow Interrupt: Off
; 0000 053F // Input Capture Interrupt: Off
; 0000 0540 // Compare A Match Interrupt: Off
; 0000 0541 // Compare B Match Interrupt: Off
; 0000 0542 TCCR3A=0x00;
	STS  139,R30
; 0000 0543 TCCR3B=0x00;
	STS  138,R30
; 0000 0544 TCNT3H=0x00;
	STS  137,R30
; 0000 0545 TCNT3L=0x00;
	STS  136,R30
; 0000 0546 ICR3H=0x00;
	STS  129,R30
; 0000 0547 ICR3L=0x00;
	STS  128,R30
; 0000 0548 OCR3AH=0x00;
	STS  135,R30
; 0000 0549 OCR3AL=0x00;
	STS  134,R30
; 0000 054A OCR3BH=0x00;
	STS  133,R30
; 0000 054B OCR3BL=0x00;
	STS  132,R30
; 0000 054C 
; 0000 054D 
; 0000 054E // External Interrupt(s) initialization
; 0000 054F // INT0: Off
; 0000 0550 // INT1: On
; 0000 0551 // INT1 Mode: Falling edge
; 0000 0552 // INT2: Off
; 0000 0553 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0554 // Interrupt on any change on pins PCINT8-15: Off
; 0000 0555 GICR|=0x80;
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
; 0000 0556 MCUCR=0x08;
	LDI  R30,LOW(8)
	OUT  0x35,R30
; 0000 0557 EMCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 0558 GIFR=0x80;
	LDI  R30,LOW(128)
	OUT  0x3A,R30
; 0000 0559 
; 0000 055A // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 055B TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 055C 
; 0000 055D ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
; 0000 055E 
; 0000 055F // USART0 initialization
; 0000 0560 // USART0 disabled
; 0000 0561 UCSR0B=0x00;
	OUT  0xA,R30
; 0000 0562 
; 0000 0563 // USART1 initialization
; 0000 0564 // USART1 disabled
; 0000 0565 UCSR1B=0x00;
	OUT  0x1,R30
; 0000 0566 
; 0000 0567 // Analog Comparator initialization
; 0000 0568 // Analog Comparator: Off
; 0000 0569 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 056A ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 056B 
; 0000 056C // SPI initialization
; 0000 056D // SPI disabled
; 0000 056E SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 056F 
; 0000 0570 // Alphanumeric LCD initialization
; 0000 0571 // Connections specified in the
; 0000 0572 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 0573 // RS - PORTA Bit 0
; 0000 0574 // RD - PORTA Bit 1
; 0000 0575 // EN - PORTA Bit 2
; 0000 0576 // D4 - PORTA Bit 4
; 0000 0577 // D5 - PORTA Bit 5
; 0000 0578 // D6 - PORTA Bit 6
; 0000 0579 // D7 - PORTA Bit 7
; 0000 057A // Characters/line: 20
; 0000 057B lcd_init(20);
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 057C 
; 0000 057D // Global enable interrupts
; 0000 057E #asm("sei")
	sei
; 0000 057F 
; 0000 0580 while(1)
_0x16B:
; 0000 0581   {
; 0000 0582 
; 0000 0583    if(PINC.0==1 && PINC.1==1){
	SBIS 0x13,0
	RJMP _0x16F
	SBIC 0x13,1
	RJMP _0x170
_0x16F:
	RJMP _0x16E
_0x170:
; 0000 0584    delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0x16
; 0000 0585 
; 0000 0586    if(PINC.0==1 && PINC.1==1){
	SBIS 0x13,0
	RJMP _0x172
	SBIC 0x13,1
	RJMP _0x173
_0x172:
	RJMP _0x171
_0x173:
; 0000 0587    delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0x16
; 0000 0588    if(PINC.0==1 && PINC.1==1){
	SBIS 0x13,0
	RJMP _0x175
	SBIC 0x13,1
	RJMP _0x176
_0x175:
	RJMP _0x174
_0x176:
; 0000 0589    ctt=0;
	LDI  R26,LOW(_ctt)
	LDI  R27,HIGH(_ctt)
	__GETD1N 0x0
	CALL __EEPROMWRD
; 0000 058A    cpm=0;
	CALL SUBOPT_0x5A
; 0000 058B    cph=0;
	CALL SUBOPT_0x60
; 0000 058C    urhfive=0;
	CALL SUBOPT_0x61
; 0000 058D    urh=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x5B
; 0000 058E    mrhfive=0;
	LDI  R30,LOW(0)
	STS  _mrhfive,R30
	STS  _mrhfive+1,R30
	STS  _mrhfive+2,R30
	STS  _mrhfive+3,R30
; 0000 058F    urhfive=0;
	CALL SUBOPT_0x61
; 0000 0590    license=0;
	LDI  R26,LOW(_license)
	LDI  R27,HIGH(_license)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
; 0000 0591    setup=1;
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 0592    m=0;
	CLR  R4
; 0000 0593    s=0;
	CLR  R5
; 0000 0594    n=0;
	CLR  R7
; 0000 0595    licensesel=0;
	CLR  R13
; 0000 0596 
; 0000 0597    }
; 0000 0598    }
_0x174:
; 0000 0599 
; 0000 059A    }
_0x171:
; 0000 059B  }
_0x16E:
	RJMP _0x16B
; 0000 059C  }
_0x177:
	NOP
	RJMP _0x177
;
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x1B,4
	RJMP _0x2000005
_0x2000004:
	CBI  0x1B,4
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x1B,5
	RJMP _0x2000007
_0x2000006:
	CBI  0x1B,5
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x1B,6
	RJMP _0x2000009
_0x2000008:
	CBI  0x1B,6
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x1B,7
	RJMP _0x200000B
_0x200000A:
	CBI  0x1B,7
_0x200000B:
	__DELAY_USB 5
	SBI  0x1B,2
	__DELAY_USB 13
	CBI  0x1B,2
	__DELAY_USB 13
	RJMP _0x20A0001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RJMP _0x20A0001
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x62
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x62
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20A0001
_0x2000013:
_0x2000010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x1B,0
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x1B,0
	RJMP _0x20A0001
_lcd_puts:
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	SBI  0x1A,4
	SBI  0x1A,5
	SBI  0x1A,6
	SBI  0x1A,7
	SBI  0x1A,2
	SBI  0x1A,0
	SBI  0x1A,1
	CBI  0x1B,2
	CBI  0x1B,0
	CBI  0x1B,1
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x16
	CALL SUBOPT_0x63
	CALL SUBOPT_0x63
	CALL SUBOPT_0x63
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	CALL SUBOPT_0x64
	LDI  R30,LOW(45)
	ST   X,R30
_0x2020003:
_0x2020005:
	CALL SUBOPT_0x65
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2020008
	CPI  R16,0
	BRNE _0x2020008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2020007
_0x2020008:
	CALL SUBOPT_0x64
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2020007:
	CALL SUBOPT_0x65
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	CALL __CPD10
	BRNE _0x2020005
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,12
	RET

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_cpm:
	.BYTE 0x4
_cph:
	.BYTE 0x4

	.ESEG
_ctt:
	.BYTE 0x4

	.DSEG
_urh:
	.BYTE 0x4
_mrh:
	.BYTE 0x4
_urhfive:
	.BYTE 0x4
_cpfive:
	.BYTE 0x4
_mrhfive:
	.BYTE 0x4

	.ESEG
_license:
	.BYTE 0x1

	.DSEG
_ava:
	.BYTE 0x1
_avb:
	.BYTE 0x1
_avc:
	.BYTE 0x1
_avd:
	.BYTE 0x1
_ave:
	.BYTE 0x1
_avf:
	.BYTE 0x1
_avg:
	.BYTE 0x1
_avh:
	.BYTE 0x1
_avi:
	.BYTE 0x1
_avj:
	.BYTE 0x1
_avk:
	.BYTE 0x1
_avl:
	.BYTE 0x1
_avm:
	.BYTE 0x1
_avn:
	.BYTE 0x1
_avo:
	.BYTE 0x1
_avp:
	.BYTE 0x1
_avq:
	.BYTE 0x1
_a:
	.BYTE 0x1
_b:
	.BYTE 0x1
_c:
	.BYTE 0x1
_d:
	.BYTE 0x1
_e:
	.BYTE 0x1
_f:
	.BYTE 0x1
_g:
	.BYTE 0x1
_h:
	.BYTE 0x1
_i:
	.BYTE 0x1
_j:
	.BYTE 0x1
_k:
	.BYTE 0x1
_l:
	.BYTE 0x1
_o:
	.BYTE 0x1
_p:
	.BYTE 0x1
_q:
	.BYTE 0x1
_ac:
	.BYTE 0x3
_bc:
	.BYTE 0x3
_cc:
	.BYTE 0x3
_dc:
	.BYTE 0x3
_ec:
	.BYTE 0x3
_fc:
	.BYTE 0x3
_gc:
	.BYTE 0x3
_hc:
	.BYTE 0x3
_ic:
	.BYTE 0x3
_jc:
	.BYTE 0x3
_kc:
	.BYTE 0x3
_lc:
	.BYTE 0x3
_mc:
	.BYTE 0x3
_ncc:
	.BYTE 0x3
_oc:
	.BYTE 0x3
_pc:
	.BYTE 0x3
_qc:
	.BYTE 0x3
_urhfivec:
	.BYTE 0xF
_mrhfivec:
	.BYTE 0xF
_cpmc:
	.BYTE 0xF
_cphc:
	.BYTE 0xF
_cttc:
	.BYTE 0x1B
_sc:
	.BYTE 0x6
_urhc:
	.BYTE 0xF
_nc:
	.BYTE 0x9
_mrhc:
	.BYTE 0xF
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x2:
	LDI  R26,LOW(_ctt)
	LDI  R27,HIGH(_ctt)
	CALL __EEPROMRDD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(_cttc)
	LDI  R31,HIGH(_cttc)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	__CPD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 126 TIMES, CODE SIZE REDUCTION:247 WORDS
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	__CPD1N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	__CPD1N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	__CPD1N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xB:
	__CPD1N 0x186A0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xC:
	__CPD1N 0xF4240
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	__CPD1N 0x989680
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	__CPD1N 0x5F5E100
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xF:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(9)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(14)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 48 TIMES, CODE SIZE REDUCTION:91 WORDS
SUBOPT_0x16:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:48 WORDS
SUBOPT_0x17:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x18:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _itoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x23:
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x29:
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2A:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(2)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _lcd_putchar
	RJMP SUBOPT_0x2F

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:48 WORDS
SUBOPT_0x31:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x32:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	__GETD2N 0x26
	CALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x34:
	STS  _urhfive,R30
	STS  _urhfive+1,R31
	STS  _urhfive+2,R22
	STS  _urhfive+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LDS  R30,_urhfive
	LDS  R31,_urhfive+1
	LDS  R22,_urhfive+2
	LDS  R23,_urhfive+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:81 WORDS
SUBOPT_0x36:
	LDS  R26,_urhfive
	LDS  R27,_urhfive+1
	LDS  R24,_urhfive+2
	LDS  R25,_urhfive+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	__GETD1N 0x64
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x38:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ltoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x39:
	RCALL SUBOPT_0x36
	__CPD2N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3A:
	LDI  R30,LOW(_urhfivec)
	LDI  R31,HIGH(_urhfivec)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3B:
	RCALL SUBOPT_0x36
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x3C:
	RCALL SUBOPT_0x36
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3D:
	RCALL SUBOPT_0x36
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x3E:
	LDS  R26,_urh
	LDS  R27,_urh+1
	LDS  R24,_urh+2
	LDS  R25,_urh+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x3F:
	__CPD2N 0x186A0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x36
	__GETD1N 0x3E8
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:51 WORDS
SUBOPT_0x41:
	LDS  R26,_mrhfive
	LDS  R27,_mrhfive+1
	LDS  R24,_mrhfive+2
	LDS  R25,_mrhfive+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x42:
	__CPD2N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(_mrhfivec)
	LDI  R31,HIGH(_mrhfivec)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x44:
	RCALL SUBOPT_0x41
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x45:
	RCALL SUBOPT_0x41
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x46:
	RCALL SUBOPT_0x41
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	RCALL SUBOPT_0x36
	__CPD2N 0x1E
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x48:
	__CPD2N 0x3E9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x49:
	LDI  R30,LOW(_nc)
	LDI  R31,HIGH(_nc)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4A:
	LDS  R30,_cpm
	LDS  R31,_cpm+1
	LDS  R22,_cpm+2
	LDS  R23,_cpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x4B:
	LDS  R26,_cpm
	LDS  R27,_cpm+1
	LDS  R24,_cpm+2
	LDS  R25,_cpm+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4C:
	LDI  R30,LOW(_cpmc)
	LDI  R31,HIGH(_cpmc)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4D:
	RCALL SUBOPT_0x4B
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4E:
	RCALL SUBOPT_0x4B
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4F:
	RCALL SUBOPT_0x4B
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x50:
	STS  _urh,R30
	STS  _urh+1,R31
	STS  _urh+2,R22
	STS  _urh+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x51:
	__CPD2N 0x9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x52:
	LDI  R30,LOW(_urhc)
	LDI  R31,HIGH(_urhc)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x53:
	__CPD2N 0x63
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x54:
	__CPD2N 0xB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x55:
	__CPD2N 0x3E7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x56:
	__CPD2N 0x65
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x57:
	LDS  R26,_mrh
	LDS  R27,_mrh+1
	LDS  R24,_mrh+2
	LDS  R25,_mrh+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x58:
	LDI  R30,LOW(_mrhc)
	LDI  R31,HIGH(_mrhc)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x59:
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5A:
	LDI  R30,LOW(0)
	STS  _cpm,R30
	STS  _cpm+1,R30
	STS  _cpm+2,R30
	STS  _cpm+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5B:
	STS  _urh,R30
	STS  _urh+1,R30
	STS  _urh+2,R30
	STS  _urh+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x5C:
	LDS  R26,_cph
	LDS  R27,_cph+1
	LDS  R24,_cph+2
	LDS  R25,_cph+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5D:
	LDI  R30,LOW(_cphc)
	LDI  R31,HIGH(_cphc)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5E:
	RCALL SUBOPT_0x5C
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5F:
	RCALL SUBOPT_0x5C
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x60:
	STS  _cph,R30
	STS  _cph+1,R30
	STS  _cph+2,R30
	STS  _cph+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x61:
	LDI  R30,LOW(0)
	STS  _urhfive,R30
	STS  _urhfive+1,R30
	STS  _urhfive+2,R30
	STS  _urhfive+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x62:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x63:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x64:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x65:
	__GETD1S 2
	__GETD2S 8
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOVW R0,R30
	MOVW R30,R22
	RCALL __EEPROMWRW
	MOVW R30,R0
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
